////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

/**
 * This object caches data for different objects.
 *
 * Data is stored with two keys: an xpath and a dataType.
 * Data is invalided with one key: an xpath.
 *
 * IDs in use:
 *
 * 0   editor types
 * 1   button states
 * 2   schema declarations
 * 3   possible children
 * 4   can move up
 * 5   can move down
 * 6   can delete
 */
function CacheHandler() 
{
  this._cache = {};
}

CacheHandler.prototype=
{
  /**
   * Add something to the cache.
   */
  put: function (xpath, dataID, value)
  {
    var entry = this._cache[xpath];
    
    if (!entry)
      entry = this._cache[xpath] = [];
      
    entry[dataID] = value;
  },

  /**
   * Get something from the cache.
   */
  get: function (xpath, dataID)
  {
    var entry = this._cache[xpath];
    
    if (!entry)
      return null;
      
    return entry[dataID];
  },

  /**
   * Invalidate an xpath in the cache.
   */
  invalidate: function (xpath)
  {
    delete this._cache[xpath];
  }
}

numScriptsLoading--;