////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//  start context code!!!
//

function InitContextMenu() {
  var s = '';

  //create an xopus canvas
  s += '<div id="xopus_canvas" class="xopus_canvas">'
  //create a contextmenu element
  + '<div id="xopus_contextmenu" oncontextmenu="return false;" unselectable="on">'
  + '<div id="xopus_contextmenu_inner" unselectable="on">'
  + '<div id="xopus_contextmenu_contentcontainer" unselectable="on">'
  + '</div>'
  + '</div>'
  + '</div>'

  //create a contextsubmenu element
  + '<div style="visibility:hidden;" id="xopus_contextsubmenu" oncontextmenu="return false;" unselectable="on">'
  + '<div id="xopus_contextsubmenu_inner" unselectable="on">'
  + '<div id="xopus_contextsubmenu_contentcontainer" unselectable="on">'
  + '</div>'
  + '</div>'
  + '</div>'
  + '</div>';
  //write the HTML
  xopus_globs.window.document.write(s);
}
InitContextMenu();

//
//  end contextmenu code!!!
/////////////////////////////////////////////////////////


function ContextMenu() {
  //properties
  this.parentEl = null;
  this.items = null;
  this.subitems = null;
  this.showAsMenu = false;
  this.dontClose = false;
  this.isVisible = false;
  this.prevParentEl = null;
  this.prevClosingTime = (new Date()).getTime();
  this.contextmenu = xopus_globs.window.document.getElementById('xopus_contextmenu');
  this.subcontextmenu = xopus_globs.window.document.getElementById('xopus_contextsubmenu');
  this.container = xopus_globs.window.document.getElementById('xopus_contextmenu_inner');
  this.content = xopus_globs.window.document.getElementById('xopus_contextmenu_contentcontainer');
  this.subcontainer = xopus_globs.window.document.getElementById('xopus_contextsubmenu_inner');
  this.subcontent = xopus_globs.window.document.getElementById('xopus_contextsubmenu_contentcontainer');
  this.itemArray = [];
  this.curItemIndex = null;
  this.subTOH = null;
  this.curSubitemid = null;
  this.curOverItem = null;

  //set width if IE
  if (xopus_globs.browser.ie) {
    this.contextmenu.style.width = '10em';
    this.subcontextmenu.style.width = '10em';
  }
}

ContextMenu.prototype = {
  draw:function(theWindow, evt, menuDefinition, dontClose, dontMove) {
    //see if this menu is already visible
    if (this.isVisible && this.menuDefinition.id && (this.menuDefinition.id == menuDefinition.id) && !dontMove && !dontClose ) {
      //hide the menu instead of showing it
      this.hide();
      return;
    }

    var items = menuDefinition.items;

    //check whether there are items to show
    if (!items || !xopus_globs.utils.objHasProp(items, null)) {
      this.hide();
      return;
    }

    //check whether the menu is already open
    if (!dontClose && !dontMove && (this.prevParentEl == evt.srcElement) && ((new Date()).getTime() - this.prevClosingTime < 500)) {
      this.hide();
      return;
    }

    // Reset button
    if (this.menuDefinition && this.parentEl && this.menuDefinition.showAsMenu) 
      this.parentEl.className = this.parentEl.className.replace(/\_down$/, '');

    //store definition and items
    menuDefinition.window = theWindow;
    this.menuDefinition = menuDefinition;
    if (!dontMove) this.parentEl = evt.srcElement;
    this.items = items;
    this.showAsMenu = (menuDefinition.showAsMenu == true);

    //determine some stuff
    this.dontClose = (dontClose == true);
    this.dontMove = (dontMove == true);

    //see if we need to show icons
    var useIcons = false;
    for (var id in items) {
      if (items[id].icon || items[id].href) {
        useIcons = true;
        break;
      }
    }

    //construct the HTML
    var s = this.constructHTML(menuDefinition);

    //make sure the menu will take its required height
    this.content.style.height = 'auto';

    this.content.innerHTML = s;

    //place the context menu
    this.positionMenu(this.contextmenu, menuDefinition, evt, dontMove);

    //show the element as down if we have to show this contextmenu as a menu
    if (menuDefinition.showAsMenu) {
      this.parentEl = evt.srcElement;
      if (this.parentEl) {
        this.parentEl.className = this.parentEl.getAttribute('oriclass') + '_down';
      }
    }

    //make visible
    this.contextmenu.style.visibility = 'visible';
    this.isVisible = true;
    if (dontClose && (this.curItemIndex != null)) ;//__xopus_alert('reset focus');
    else this.curItemIndex = null;
    this.itemArray = [];
    for (var itemid in this.items) this.itemArray[this.itemArray.length] = itemid;

    //select the first item if we were created by a key event
    if (evt.type && (evt.type.indexOf('key') != -1)) {
        this.curItemIndex = 0;
        var item = this.items[this.itemArray[this.curItemIndex]];
        while (item && item.disabled) {
          this.curItemIndex++;
          item = this.items[this.itemArray[this.curItemIndex]];
        }
        if (item) {
          var el = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.itemArray[this.curItemIndex]);
          if (el && this.itemArray && this.itemArray[this.curItemIndex]) this.doMouseOver({srcElement:el, target:el});
        }
    }

    //show a dropshadow! nice!!!
    xopus_globs.dropshadow.show(this.contextmenu, false);

    xopus_globs.allowEditKeys = false;
  },
  hide: function()
  {
    this.contextmenu.style.visibility = 'hidden';
    this.subcontextmenu.style.visibility = 'hidden';

    //hide dropshadows
    xopus_globs.dropshadow.hide();
    xopus_globs.dropshadow.hide(true);

//TODO: OPRUIMEN?
//    this.content.style.overflow = '';
//    this.content.style.width = 'auto';
//    this.content.style.height = 'auto';
//    this.content.style.marginRight = '0px';
    this.isVisible = false;
    this.prevParentEl = this.parentEl;
    this.prevClosingTime = (new Date()).getTime();
    this.curItemIndex = null;
    this.itemArray = null;

    // Reset button
    if (this.menuDefinition && this.parentEl && this.menuDefinition.showAsMenu) 
      this.parentEl.className = this.parentEl.className.replace(/\_down$/, '');

    xopus_globs.allowEditKeys = true;
  },
  doMouseOver:function(evt) {
    if (!this.isVisible) return true;

    //find the element
    var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
    if (el.nodeType == 3) el = el.parentNode;
    while (el && el.getAttribute && !el.getAttribute('itemIndex')) el = el.parentNode;
    if (!el || !el.getAttribute || (el.className.indexOf('_dis') != -1)) return true;

    //check whether this item was already selected
    if (el.isSelected) return true;

    if ((this.curItemIndex != null) && this.itemArray && this.itemArray[this.curItemIndex]) {
      var el2 = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.itemArray[this.curItemIndex]);
      this.doMouseOut({srcElement:el2, target:el2});
    }

    //make the element look selected
    this.setSelected(el, true);

    var itemID = el.getAttribute('itemID');
    var item = this.items[itemID];

    if (item) {
      if (this.curOverItem && (item != this.curOverItem)) {
        //force mouse out of curOverItem
        this.doMouseOut(null, this.curOverItem);
      }

      //remember what item
      this.curOverItem = item;
    }

    //check if item found, if not it may be a sub item
    if (!item && this.subitems) item = this.subitems[itemID];

    if (!item) return;

    item.id = itemID;
    if (!el.item) {
      el.item = this.items[itemID];
      if (!el.item) el.item = this.subitems[itemID];
    }
    this.curItemIndex = 1*el.getAttribute('itemIndex');

    if (this.subTOH) {
      clearTimeout(this.subTOH);
      this.subTOH = null;
    }
    if ((itemID != this.curSubitemid) && this.subitems && !this.subitems[itemID]) this.hideSubmenu();
//if (item.menu) status = 'el heeft item dat een menu heeft ' + new Date();
    if (el.item.menu) this.subTOH = setTimeout('xopus_globs.contextmenu.showSubmenu("' + itemID + '");', 200);

    //execute mouseover handler
    xopus_globs.utils.runHandler(item, 'onmouseover', item.id);

    //see if we need to scroll
    var sh = xopus_globs.window.document.body.offsetHeight;
    var st = xopus_globs.window.document.documentElement.scrollTop + xopus_globs.window.document.body.scrollTop;
    var bcrTR = el.getBoundingClientRect();
    var container = el.parentNode.parentNode.parentNode;
    var bcrContainer = container.getBoundingClientRect();
    if (bcrTR.top < bcrContainer.top) container.scrollTop -= (bcrContainer.top - bcrTR.top + (bcrTR.bottom - bcrTR.top - 2));
    if (bcrTR.bottom > bcrContainer.bottom) container.scrollTop += (bcrTR.bottom - bcrContainer.bottom + (bcrTR.bottom - bcrTR.top - 2));

    //signal we have handled this event
    return false;
  },
  doMouseOut:function(evt, item) {
    if (!item) {
      //find the element
      var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
      if (!el) return true;
      if (el.nodeType == 3) el = el.parentNode;
      while (el && el.getAttribute && !el.getAttribute('itemIndex')) el = el.parentNode;
      if (!el || !el.getAttribute || (el.className.indexOf('_dis') != -1)) return true;

      //check whether this item wasn't already selected
      if (!el.isSelected) return true;

      var itemID = el.getAttribute('itemID');

      var item = this.items[itemID];
      //check if item found, if not it may be a sub item
      if (!item) item = this.subitems[itemID];
    } else {
      var el = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + item.id);
      if (!el) el = xopus_globs.window.document.getElementById('xopus_contextsubmenu_item_' + item.id);
      var itemID = item.id;
    }

    if (itemID != this.curSubitemid) {
      //stop the element from looking selected
      this.setSelected(xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + itemID), false);
    }

    if ((itemID != this.curSubitemid) && this.subitems && !this.subitems[itemID]) this.hideSubmenu();

    if (this.itemArray && (this.itemArray[this.curItemIndex] == itemID)) this.curItemIndex = null;

    if (this.subTOH) {
      clearTimeout(this.subTOH);
      this.subTOH = null;
    }

    //execute mouseout handler
    if (item) xopus_globs.utils.runHandler(item, 'onmouseout', item.id);

    //signal we have handled this event
    return false;
  },
  doMouseDown:function(evt, theWindow) {
    if (!this.isVisible) return true;

    if (theWindow != xopus_globs.window) {
      this.doBlur();
      return false;
    }

    //see if we clicked outside the contextmenu
    var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
    if (el.nodeType == 3) el = el.parentNode;
    while (el && (el.id != 'xopus_contextmenu') && (el.id != 'xopus_contextsubmenu')) el = el.parentNode;
    if (!el) {
      this.doBlur();
      return false;
    }
    return true;
  },
  doMouseUp:function(evt) {
    if (!this.isVisible) return true;

    //find the element
    var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
    if (el.nodeType == 3) el = el.parentNode;
    while (el && el.getAttribute && !el.getAttribute('itemIndex')) el = el.parentNode;
    if (!el || !el.getAttribute || (el.className.indexOf('_dis') != -1)) return true;

    //make the event accessible
    if (xopus_globs.browser.moz) window.event = evt;

    //check whether the left mouse button was pressed
    if (this.showAsMenu && ((evt.button || evt.which) != 1)) return true;

    var itemID = el.getAttribute('itemID');
    var item = this.items[itemID];

    //check whether this item has a submenu, if so, don't execute
    if (item && item.menu) return false;

    //check if item found, if not it may be a sub item
    if (!item) item = this.subitems[itemID];

    //execute the item
    item.id = itemID;
    if (!this.dontClose) this.doBlur();

    //execute onclick handler
    xopus_globs.utils.runHandler(item, 'onclick', item.id);

    //signal we have handled this event
    return false;
  },
  doResize:function() {
    if (!this.isVisible) return true;

    this.doBlur();
    return true;
  },
  doBlur:function(evt) {
    //can be called with or without evt
    //with: will see if the event took place outside of the contextmenu
    //without: will hide always
    if (this.isVisible) {
      //see if the event took place outside of the contextmenu
      var el = (evt?evt.srcElement:null);
      while (el && (el.id != 'xopus_contextmenu')) el = el.parentNode;
      if (!el) {
        if (!evt || (typeof(evt.type) != "undefined") || (evt.type != "keydown") || (!evt.ctrlKey && !evt.altKey)) {
          this.hide();
        }
      }
      this.subcontextmenu.style.visibility = 'hidden';
      this.curSubitemid = null;
    }
  },
  doKeyDown:function(evt) {
    //leave untouched if invisible
    if (!this.isVisible) return true;

    //catch some keys
    var prevItemIndex = this.curItemIndex;
    var keyUsed = true;
    switch (evt.keyCode) {
      case 27:
        //escape
        this.hide();
        break;
      case 36:
        //home
        this.curItemIndex = 0;
        while ((this.items[this.itemArray[this.curItemIndex]].disabled) && (this.curItemIndex < this.itemArray.length-1)) this.curItemIndex++;
        break;
      case 35:
        //end
        this.curItemIndex = this.itemArray.length - 1;
        while ((this.items[this.itemArray[this.curItemIndex]].disabled) && (this.curItemIndex > 0)) this.curItemIndex--;
        break;
      case 33:
        //page up
        if (this.curItemIndex == null) this.curItemIndex = this.itemArray.length - 1;
        this.curItemIndex -= 5;
        if (this.curItemIndex < 0) this.curItemIndex = 0;
        while ((this.items[this.itemArray[this.curItemIndex]].disabled) && (this.curItemIndex < this.itemArray.length)) this.curItemIndex++;
        break;
      case 34:
        //page down
        if (this.curItemIndex == null) this.curItemIndex = 0;
        this.curItemIndex += 5;
        if (this.curItemIndex >= this.itemArray.length) this.curItemIndex = this.itemArray.length - 1;
        while ((this.items[this.itemArray[this.curItemIndex]].disabled) && (this.curItemIndex > 0)) this.curItemIndex--;
        break;
      case 37:
        //arrow left
        if (this.menuDefinition.showAsGrid) {
          do {
            if ((this.curItemIndex == null) || (this.curItemIndex == 0)) this.curItemIndex = this.itemArray.length - 1;
            else this.curItemIndex--;
            var item = this.items[this.itemArray[this.curItemIndex]];
          } while (item.disabled);
        } else {
          if (this.items != this.menuDefinition.items) {
            //hide the submenu
            var el = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.itemArray[this.curItemIndex]);
            this.doMouseOut({srcElement:el, target:el});
            this.subcontextmenu.style.visibility = 'hidden';

            //go to mainmenu
            prevItemIndex = -1;
            this.curItemIndex = this.mainItemIndex;
            this.items = this.menuDefinition.items;
            this.itemArray = [];
            for (var itemid in this.items) this.itemArray[this.itemArray.length] = itemid;
          }
        }
        break;
      case 38:
        //arrow up
        if (this.menuDefinition.showAsGrid) {
          if ((this.curItemIndex == null) || (this.curItemIndex == 0)) {
            this.curItemIndex = this.itemArray.length - 1;
            //go to start of row
          } else {
            //go to same spot on previous row
            var el = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.itemArray[this.curItemIndex]);
            var bcr = el.getBoundingClientRect();
            do {
              this.curItemIndex--;
              if (this.curItemIndex < 0) {
                this.curItemIndex = this.itemArray.length - 1;
                bcr.top = 10000;
              }
              var newel = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.itemArray[this.curItemIndex]);
              if (newel) var newbcr = newel.getBoundingClientRect();
              var item = this.items[this.itemArray[this.curItemIndex]];
            } while ((item && item.disabled) || (newel && ((newbcr.left > bcr.left) || (newbcr.top >= bcr.top))));
          }
        } else {
          var item = null;
          do {
            if ((this.curItemIndex == null) || (this.curItemIndex == 0)) this.curItemIndex = this.itemArray.length - 1;
            else this.curItemIndex--;
            item = this.items[this.itemArray[this.curItemIndex]];
          } while (item && item.disabled);
        }
        break;
      case 39:
        //arrow right
        if (this.menuDefinition.showAsGrid) {
          do {
            if ((this.curItemIndex == null) || (this.curItemIndex == this.itemArray.length-1)) this.curItemIndex = 0;
            else this.curItemIndex++;
            var item = this.items[this.itemArray[this.curItemIndex]];
          } while (item.disabled);
        } else {
          var item = this.items[this.itemArray[this.curItemIndex]];
          if (item && item.menu && item.menu.items) {
            //go to submenu
            this.mainItemIndex = this.curItemIndex;
            prevItemIndex = -1;
            this.items = item.menu.items;
            this.itemArray = [];
            for (var itemid in this.items) this.itemArray[this.itemArray.length] = itemid;

            this.curItemIndex = null;
try {
            do {
              if ((this.curItemIndex == null) || (this.curItemIndex == this.itemArray.length-1)) this.curItemIndex = 0;
              else this.curItemIndex++;
              var item = this.items[this.itemArray[this.curItemIndex]];
            } while (item.disabled);
} catch(e) {
__xopus_alert(e.message + ', ' + this.curItemIndex + ', ' + this.itemArray + ', ' + this.itemArray.length);
}
            //show the submenu
            this.subcontextmenu.style.visibility = 'visible';
          }
        }
        break;
      case 40:
        //arrow down
//BUG BUG BUG: dit levert net iets ander gedrag op dan pijltje omhoog! later oplossen
        if (this.menuDefinition.showAsGrid) {
          if (this.curItemIndex == null) this.curItemIndex = 0;
          else {
            //go to same spot on next row
            var el = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.itemArray[this.curItemIndex]);
            var bcr = el.getBoundingClientRect();
            do {
              this.curItemIndex++;
              if (this.curItemIndex > this.itemArray.length - 1) {
                this.curItemIndex = 0;
                bcr.top = -10000;
              }
              var newel = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.itemArray[this.curItemIndex]);
              if (newel) var newbcr = newel.getBoundingClientRect();
              var item = this.items[this.itemArray[this.curItemIndex]];
            } while ((item && item.disabled) || (newel && ((newbcr.left < bcr.left) || (newbcr.top <= bcr.top))));
          }
        } else {
          var item = null;
          do {
            if ((this.curItemIndex == null) || (this.curItemIndex >= this.itemArray.length-1)) this.curItemIndex = 0;
            else this.curItemIndex++;
            item = this.items[this.itemArray[this.curItemIndex]];
          } while (item && item.disabled);
        }
        break;
      case 13:
      case 32:
        var el = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.itemArray[this.curItemIndex]);
        this.doMouseUp({srcElement:el, target:el, button:1});
        break;
      default:
        keyUsed = false;
    }

    if (this.curItemIndex != prevItemIndex) {
      if (this.itemArray && this.itemArray[prevItemIndex] && (prevItemIndex != null)) {
        var el = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.itemArray[prevItemIndex]);
        this.doMouseOut({srcElement:el, target:el});
      }
      if (this.itemArray && this.itemArray[this.curItemIndex]) {
        var el = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.itemArray[this.curItemIndex]);
        if (el) this.doMouseOver({srcElement:el, target:el});
      }
    }
    
    //cancel the event
    return !keyUsed;
  },
  doKeyPress:function(evt) {
    //cancel keys if visible, not if not
    return !this.isVisible;
  },
  constructHTML:function(menuDefinition) {
    var items = menuDefinition.items;
    var s = '<table id="xopus_contextmenu_' + menuDefinition.id + '" ' + (menuDefinition.showAsGrid?' class="xopus_contextmenu_grid"':'') + ' cellspacing="0" cellpadding="0" border="0" unselectable="on">';
    var itemIndex = -1;
    
    if (menuDefinition.showAsGrid) {
      s += '<tr unselectable="on">';
      var rowCount = 0;
      for (var id in items) {
        var item = items[id];
        itemIndex++;
        rowCount++;
        if (id.indexOf('separator') == 0) {
          s += '</tr><tr unselectable="on">';
          rowCount = 0;
          item.disabled = true;
          continue;
        }
        if ((rowCount%8 == 0) && (rowCount != 0)) s += '</tr><tr unselectable="on">';
        var postfix = (item.disabled?'_dis':'');
        s += '<td align="center" unselectable="on" itemIndex="' + itemIndex + '" id="xopus_contextmenu_item_' + id + '" itemID="' + id + '" oriclass="xopus_contextmenu_item' +  postfix + '" class="xopus_contextmenu_item' +  postfix + '">' + item.name + '</td>';
      }
    } else {
      var anySelect = false;
      var anyIcon = false;
      var anyMore = false;
      var ids = [];
      var itemIndexs = [];
      var selectIcons = [];
      var selectTypes = [];
      var moreIcons = [];
      var icons = [];
      var postfixs = [];
      var disableds = [];
      var contents = [];
      var i = 0;
      var prevWasSeparator = true;
      for (var id in items) {
        //see if the previous and the current item are both separators,
        //if so skip this one
        if (prevWasSeparator && (id.indexOf('separator') != -1)) continue;

        //see if hidden, if so: skip
        if (items[id].hidden) {
          items[id].disabled = true;
          continue;
        }

        //remember whether this item is a separator
        prevWasSeparator = (id.indexOf('separator') != -1);

        //store the id of this item
        ids[i] = id;

        itemIndex++;
        var item = items[id];
        if (id.indexOf('separator') != -1) {
          item.disabled = true;
        } else {
          //check whether submenu has any item enabled
          if (item.menu && !item.disabled) {
            var allDisabled = true;
            for (var subid in item.menu.items) {
              var subitem = item.menu.items[subid];
              if (!subitem.disabled) {
                allDisabled = false;
                break;
              }
            }
            item.disabled = item.disabled || allDisabled;
          }

          itemIndexs[i] = itemIndex;
          postfixs[i] = (item.disabled?'_dis':(item.href?'_link':''));

          disableds[i] = item.disabled;

          selectIcons[i] = false;
          selectTypes[i] = 'select';
          if (item.checked) {
            if (xopus_globs.browser.ie) {
              selectIcons[i] = 'a';
              selectTypes[i] = 'check_ie';
            } else {
              selectIcons[i] = '&#97;';
              selectTypes[i] = 'check_moz';
            }
          } else if (item.bullited) {
            selectIcons[i] = '&bull;';
            selectTypes[i] = 'bullit';
          } else if (typeof(item.checked) != 'undefined') {
            selectIcons[i] = '  ';
            selectTypes[i] = 'check_nop';
          }
          anySelect = anySelect || (selectIcons[i] != false);

          moreIcons[i] = item.menu?'&#52;':false;
          anyMore = anyMore || (moreIcons[i] != false);

          icons[i] = '';
          if (item.icon) icons[i] = item.icon;
          else if (item.href) icons[i] = xopus_globs.basePath + 'xopus/contextmenu/media/icons/' + (xopus_globs.browser.ie?'favorite':'bookmark') + '.gif';
          anyIcon = anyIcon || (icons[i] != '');

          contents[i] = item.name?item.name:xopus_globs.locale.getString(id);
        }
        i++;
      }
      var itemHTMLs = [];
      for (var i=0; i<contents.length; i++) {
        if (ids[i].indexOf('separator') != -1) {
          itemHTMLs[i] = '<tr class="xopus_contextmenu_separator" disabled="true" unselectable="on"><td colspan="4"><img src="' + xopus_globs.basePath + 'xopus/media/nix.gif" galleryimg="no" height="1" unselectable="on" /></td></tr>';
        } else {
          itemHTMLs[i] = '<tr id="xopus_contextmenu_item_' + ids[i] + '" itemID="' + ids[i] + '"'
          + ' unselectable="on" itemIndex="' + itemIndexs[i] + '"'
          + ' height="19"'
          + ' oriclass="xopus_contextmenu_item' +  postfixs[i] + '" class="xopus_contextmenu_item' +  postfixs[i] + '"'
          + (disableds[i]?' disabled="true"':'"')
          + '><td class="xopus_contextmenu_spacer" unselectable="on">&nbsp;</td>'

          //select (check or bullit)
          + (anySelect?('<td class="xopus_contextmenu_' + selectTypes[i] + '"'
          + (selectIcons[i]?(' width="10" unselectable="on"><span>' + selectIcons[i] + '</span>'):'>')
          + '</td>'):'')

          + (anyIcon?('<td'
          + ' class="xopus_contextmenu_icontd" unselectable="on" align="left" valign="top">'
          + (icons[i]?'<img src="' + (icons[i]?((disableds[i] && xopus_globs.useMozOpacity)?(xopus_globs.basePath + 'xopus/media/icons/raster' + (anySelect?'2':'1') + '.gif" style="background:url(' + icons[i] + ');'):icons[i]):xopus_globs.basePath + 'xopus/media/nix.gif') + '" class="xopus_contextmenu_icon' + (disableds[i]?'_dis':'') + '" galleryimg="no" width="20" height="20" align="top" hspace="0" vspace="0" border="0" unselectable="on" />':'')
          + '</td>'):'')

          + '<td class="xopus_contextmenu_content" width="100%" unselectable="on"><nobr unselectable="on">' + contents[i] + '</nobr></td>'

          //sub menu?
          + (anyMore?('<td class="xopus_contextmenu_more" width="0%" unselectable="on">'
          + (moreIcons[i]?('<span>' + moreIcons[i] + '</span>'):'')
          + '</td>'):'')
        
          + '</tr>';
        }
      }
      s += itemHTMLs.join('');
    }
    s += '</table>';
//__xopus_alert(s);

    //store some stuff for future reference
    menuDefinition.hasMore = anyMore;

    return s;
  },
  positionMenu:function(menuEl, menuDefinition, evt, dontMove) {
    var x = evt.clientX;
    var y = evt.clientY;
    if (!dontMove) {
      //get some dimensions
      var w = menuEl.offsetWidth;
      var h = menuEl.offsetHeight;
      var sw = xopus_globs.window.document.body.offsetWidth;
      var sh = xopus_globs.window.document.body.offsetHeight;

      //see if we have to show this as a menu or a contextmenu
      if (menuDefinition.showAsMenu) {
        //get coordinates from element
        var bcr = evt.srcElement.getBoundingClientRect();

        if (typeof(menuDefinition.alignment) != 'undefined') {
          switch(menuDefinition.alignment) {
            case xopus_consts.TOPLEFT:
            case xopus_consts.BOTTOMLEFT:
              x = bcr.left - 1;
              if ((x+w > sw) && (bcr.right > (sw - bcr.left))) {
                x = bcr.right - w + 1;
                menuDefinition.alignment = (menuDefinition.alignment==xopus_consts.TOPLEFT)?xopus_consts.TOPRIGHT:xopus_consts.BOTTOMRIGHT;
              }
              break;
            case xopus_consts.TOPRIGHT:
            case xopus_consts.BOTTOMRIGHT:
              x = bcr.right - w + 1;
              if ((x+w > sw) && ((sw - bcr.left > bcr.right))) {
                x = bcr.left - 1;
                menuDefinition.alignment = (menuDefinition.alignment==xopus_consts.TOPRIGHT)?xopus_consts.TOPLEFT:xopus_consts.BOTTOMLEFT;
              }
              break;
            case xopus_consts.LEFTTOP:
            case xopus_consts.LEFTBOTTOM:
              x = bcr.left - w + 1;
              if ((x < 0) && ((sw - bcr.right) > bcr.left)) {
                x = bcr.right - 1;
                menuDefinition.alignment = (menuDefinition.alignment==xopus_consts.LEFTTOP)?xopus_consts.RIGHTTOP:xopus_consts.RIGHTBOTTOM;
              }
              break;
            case xopus_consts.RIGHTTOP:
            case xopus_consts.RIGHTBOTTOM:
              x = bcr.right - 1;
              if ((x+w > sw) && (bcr.left > (sw - bcr.right))) {
                x = bcr.left - w + 1;
                menuDefinition.alignment = (menuDefinition.alignment==xopus_consts.RIGHTTOP)?xopus_consts.LEFTTOP:xopus_consts.LEFTBOTTOM;
              }
              break;
          }
          switch(menuDefinition.alignment) {
            case xopus_consts.TOPLEFT:
            case xopus_consts.TOPRIGHT:
              y = bcr.top - h + 1;
              if ((y < 0) && ((sh - bcr.bottom > bcr.top))) {
                y = bcr.bottom - 1;
                menuDefinition.alignment = (menuDefinition.alignment==xopus_consts.TOPLEFT)?xopus_consts.BOTTOMLEFT:xopus_consts.BOTTOMRIGHT;
              }
              break;
            case xopus_consts.BOTTOMLEFT:
            case xopus_consts.BOTTOMRIGHT:
              y = bcr.bottom + 1;
              if ((y + h > sh) && (bcr.top > (sh - bcr.bottom))) {
                y = bcr.top - h + 2;
                menuDefinition.alignment = (menuDefinition.alignment==xopus_consts.BOTTOMLEFT)?xopus_consts.TOPLEFT:xopus_consts.TOPRIGHT;
              }
              break;
            case xopus_consts.LEFTTOP:
            case xopus_consts.RIGHTTOP:
              y = bcr.top - 1;
              if ((y + h > (sh - 10)) && (bcr.bottom > (sh - bcr.top))) {
                y = bcr.bottom - h + 2;
                if (y < 0) y = (sh - h)/3;
                menuDefinition.alignment = (menuDefinition.alignment==xopus_consts.LEFTTOP)?xopus_consts.LEFTBOTTOM:xopus_consts.RIGHTBOTTOM;
              }
              break;
            case xopus_consts.LEFTBOTTOM:
            case xopus_consts.RIGHTBOTTOM:
              y = bcr.bottom - h + 1;
              if ((y < 0) && ((sh - bcr.top) > bcr.bottom)) {
                y = bcr.top - 1;
                menuDefinition.alignment = (menuDefinition.alignment==xopus_consts.LEFTBOTTOM)?xopus_consts.LEFTTOP:xopus_consts.RIGHTTOP;
              }
              break;
          }
        } else {
          x = bcr.left;
          y = bcr.bottom;

          //calculate optimal position
          if ((x + w > sw) && ((bcr.left - w > 0) || (w - bcr.left < (x + w) - sw))) x = bcr.right - w;
          if (x < 0) x = 0;
//__xopus_alert(y + ', ' + h + ', ' + bcr.top + ', ' + sh);
          if ((y + h > sh) && ((bcr.top - h > 0) || (h - bcr.top < (y + h) - sh))) y = bcr.top - h;
          if (y < 0) y = 0;
        }
      } else {
        //get coordinates from last event
        x = evt.clientX;
        y = evt.clientY;
        menuDefinition.alignment = xopus_consts.RIGHTTOP;

        //calculate optimal position
        if (x + w > sw - 10) {
          x -= w;
          menuDefinition.alignment = xopus_consts.LEFTTOP;
        }
        if (x < 10) x = 10;
        if (y + h > sh - 10) y -= h;
        if (y < 1) y = 1;
      }

      //see if the menu is too heigh for the available space
      var dy = 0;
      if (menuDefinition.isSubmenu) {
        if (h > sh) dy += h - (sh-10);
        if (y < 1) y = 2;
        if (y+(h-dy) > sh) {
          y = sh - 10 - (h - dy);
          if (y < 1) y = 2;
        }
      } else {
        if (y+h > sh-1) dy += (y+h) - (sh-10);
        if (y < 1) dy += 1 - y + 10;
      }

      if (dy > 0) {
        var content = menuEl.childNodes[0].childNodes[0];
        content.style.overflow = 'auto';
        if (xopus_globs.browser.moz) content.style.width = (content.childNodes[0].offsetWidth + 16) + 'px';
        content.style.height = (h - dy) + 'px';
        content.style.marginRight = '1px';
  
        //correct vertical position if needed
        if (menuDefinition.showAsMenu) {
          switch (menuDefinition.alignment) {
            case xopus_consts.TOPLEFT:
            case xopus_consts.TOPRIGHT:
            case xopus_consts.RIGHTBOTTOM:
            case xopus_consts.LEFTBOTTOM:
              y += dy - 6;
          //    y = bcr.top - content.offsetHeight - 6;
          }
        }
        switch (menuDefinition.alignment) {
          case xopus_consts.LEFTTOP:
          case xopus_consts.LEFTBOTTOM:
            x -= 17;
        }
      }

      //calculate offsets that are a result of the position of the toolbar
      var offsetX = 0;
      var offsetY = 0;
      if (menuDefinition.window != xopus_globs.window) {
        var bcr = xopus_globs.site.getBoundingClientRect();
        offsetX = bcr.left;
        offsetY = bcr.top;
      }

      //place
      menuEl.style.top = offsetY + y + 'px';
      menuEl.style.left = offsetX + x + 'px';
    }
  },
  showSubmenu:function(id) {
    var item = this.items[id];
    if (!item) return;

    this.curSubitemid = id;
    this.subitems = item.menu.items;

    //construct the HTML
    var s = this.constructHTML(item.menu);
    this.subcontent.innerHTML = s;

    item.menu.isSubmenu = true;
    item.menu.showAsMenu = true;
    item.menu.alignment = xopus_consts.RIGHTTOP;
    item.menu.window = xopus_globs.window;

    var el = xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.curSubitemid);
    var bcr = el.getBoundingClientRect();
    this.positionMenu(this.subcontextmenu, item.menu, { srcElement:el, clientX:(bcr.right-9), clientY:(bcr.top+5) }, false);

    this.subcontextmenu.style.visibility = 'visible';

    //show a dropshadow! nice!!!
    xopus_globs.dropshadow.show(this.subcontextmenu, true);
  },
  hideSubmenu:function() {
    this.subcontextmenu.style.visibility = 'hidden';

    //hide dropshadow
    xopus_globs.dropshadow.hide(true);

    this.subcontent.style.overflow = '';
    this.subcontent.style.width = 'auto';
    this.subcontent.style.height = 'auto';
    this.subcontent.style.marginRight = '0px';
    if (this.curSubitemid) {
      this.setSelected(xopus_globs.window.document.getElementById('xopus_contextmenu_item_' + this.curSubitemid), false);
      this.curSubitemid = null;
    }
    this.items = this.menuDefinition.items;
    this.itemArray = [];
    for (var itemid in this.items) this.itemArray[this.itemArray.length] = itemid;
  },
  setSelected: function(el, isSelected) {
    if (!el) return;

    el.style.background = (isSelected?'#83AF9E':'none');
    switch (el.className) {
      case 'xopus_contextmenu_item':
        el.style.color = (isSelected?'white':'black');
        break;
      case 'xopus_contextmenu_item_link':
        el.style.textDecoration = (isSelected?'underline':'none');
        break;
    }
    el.isSelected = isSelected;
  },
  doNothing:function(evt) {
    //cancel if visible
    return !this.isVisible;
  }
};

numScriptsLoading--;
