////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

function Dialog() {
  //create dialog 'window'
  var div = document.createElement('div');
  div.id = 'xopus_dialog';
  div.className = 'xopus_dialog';
  this.dialog = document.body.appendChild(div);
  this.dialog.innerHTML = ''
  + '<div id="xopus_dialog_inner" class="xopus_dialog_inner" unselectable="on">'
  + '<div id="xopus_dialog_contents" unselectable="on"></div>'
  + '<div id="xopus_dialog_buttons" class="xopus_dialog_buttons3">'
  + '<img src="' + xopus_globs.basePath + 'xopus/media/nix.gif" galleryimg="no" id="xopus_dialog_separator" />'
  + '<div id="xopus_dialog_ok" unselectable="on"><nobr><a href="" id="xopus_dialog_ok2" ondragstart="return false;" onmouseout="this.blur();" onclick="xopus_globs.dialog.hide(\'ok\'); return false;">' + xopus_globs.locale.getString('ok') + '</a></nobr></div>'
  + '<div id="xopus_dialog_maybe" unselectable="on"><nobr><a href="" onclick="xopus_globs.dialog.hide(\'maybe\'); return false;" id="xopus_dialog_maybe2">' + xopus_globs.locale.getString('maybe') + '</a></nobr></div>'
  + '<div id="xopus_dialog_cancel" unselectable="on"><nobr><a href="" onclick="xopus_globs.dialog.hide(\'cancel\'); return false;" id="xopus_dialog_cancel2">' + xopus_globs.locale.getString('cancel') + '</a></nobr></div>'
  + '<br clear="all" /></div>'
  + '</div>';
  this.dialogContents = document.getElementById('xopus_dialog_contents');
  this.dialogButtons = document.getElementById('xopus_dialog_buttons');
  this.dialogOK = document.getElementById('xopus_dialog_ok');
  this.dialogOK2 = document.getElementById('xopus_dialog_ok2');
  this.dialogCancel = document.getElementById('xopus_dialog_cancel');
  this.dialogCancel2 = document.getElementById('xopus_dialog_cancel2');
  this.dialogMaybe = document.getElementById('xopus_dialog_maybe');
  this.dialogMaybe2 = document.getElementById('xopus_dialog_maybe2');
  
  xopus_globs.framework.attachEvent(this.dialog, 'onclick', this, 'doClick');
  xopus_globs.framework.attachEvent(this.dialog, 'oncontextmenu', this, 'doContextmenu');

  this.isVisible = false;
  this.toh = null;
  this.obj = null;
  this.okhnd = null;
  this.cancelhnd = null;
  this.maybehnd = null;
  this.type = '';
  this.useKeys = true;
  this.activeButtons = null;
  this.curButtonIdx = -1;
  this.prevAllowEditKeys = true;
}

Dialog.prototype = {
  splash:function(html, msToHide) {
    this.show('splash', html, null, null, null, null, msToHide, xopus_globs.locale.getString('ok'), null, null, true, false);
  },
  alert:function(html, obj, okhnd, cancelhnd) {
    this.show('alert', html, obj, okhnd, cancelhnd, null, null, xopus_globs.locale.getString('ok'), xopus_globs.locale.getString('cancel'), null, true, false);
  },
  confirm:function(html, obj, yeshnd, nohnd) {
    this.show('alert', html, obj, yeshnd, nohnd, null, null, xopus_globs.locale.getString('yes'), xopus_globs.locale.getString('no'), null, true, false);
  },
  show:function(dialogtype, html, obj, okhnd, cancelhnd, maybehnd, msToHide, okTxt, cancelTxt, maybeTxt, useKeys, leftToRight) {
    if (this.toh) clearTimeout(this.toh);
    this.toh = null;

    if (xopus_globs.browser.ie) {
      this.dialogContents.style.overflow = "auto";
      this.dialogContents.style.height = "100%";
    }
    this.dialogContents.innerHTML = html;

    //special stuff for macs and left-to-right buttons: switch them
    if (leftToRight == true) {
      if (xopus_globs.browser.mac && cancelhnd) {
        var tmp = okhnd;
        okhnd = cancelhnd;
        cancelhnd = tmp;
        tmp = okTxt;
        okTxt = cancelTxt;
        cancelTxt = tmp;
      }
    }

    this.useKeys = (useKeys == true);
    this.activeButtons = [];
    this.type = dialogtype;
    this.obj = obj;
    this.okhnd = okhnd;
    this.cancelhnd = cancelhnd;
    this.maybehnd = maybehnd;
    this.position();

    var numButtons = 0;
    tempActiveButtons = [];
    this.curButtonIdx = 0;
    this.dialog.className = 'xopus_dialog_' + dialogtype;
    this.dialog.style.visibility = 'visible';
    if (okhnd || cancelhnd || maybehnd) this.dialogButtons.style.display = 'block';
    if (okhnd) {
      numButtons++;
      tempActiveButtons.push(this.dialogOK2);
      this.dialogOK2.innerHTML = '&nbsp;' + okTxt + '&nbsp;';
      this.dialogOK.style.display = 'inline';
      this.setButtonState(this.dialogOK2, false);
    } else {
      this.dialogOK.style.display = 'none';
    }
    if (cancelhnd) {
      numButtons++;
      tempActiveButtons.push(this.dialogCancel2);
      this.dialogCancel2.innerHTML = '&nbsp;' + cancelTxt + '&nbsp;';
      this.dialogCancel.style.display = 'inline';
      this.setButtonState(this.dialogCancel2, false);
    } else {
      this.dialogCancel.style.display = 'none';
    }
    if (maybehnd) {
      numButtons++;
      tempActiveButtons.push(this.dialogMaybe2);
      this.dialogMaybe2.innerHTML = '&nbsp;' + maybeTxt + '&nbsp;';
      this.dialogMaybe.style.display = 'inline';
      this.setButtonState(this.dialogMaybe2, false);
    } else {
      this.dialogMaybe.style.display = 'none';
    }

    this.dialogButtons.className = "xopus_dialog_buttons" + numButtons;

    if (this.useKeys) {
      //rearrange the active buttons to left-to-right order
      if (xopus_globs.browser.win) {
        switch(tempActiveButtons.length) {
          case 1:
          case 2:
            this.activeButtons = tempActiveButtons;
            break;
          case 3:
            this.activeButtons = [tempActiveButtons[0], tempActiveButtons[2], tempActiveButtons[1]];
            break;
        }
      } else {
        switch(tempActiveButtons.length) {
          case 1:
          case 2:
            this.activeButtons = [];
            for (var i=tempActiveButtons.length; i>=0; i--) this.activeButtons.push(tempActiveButtons[i]);
            break;
          case 3:
            this.activeButtons = [tempActiveButtons[2], tempActiveButtons[0], tempActiveButtons[1]];
            break;
        }
      }

      if (this.activeButtons && this.activeButtons.length > 0) {
        this.setButtonState(this.activeButtons[0], true);
      }
    }

    this.prevAllowEditKeys = xopus_globs.allowEditKeys;
    xopus_globs.allowEditKeys = false;

    if (msToHide) this.toh = setTimeout('xopus_globs.dialog.hide();', msToHide);

    //show a dropshadow! nice!!!
if (lon)    xopus_globs.dropshadow.show(this.dialog);

    //see if we have input fields
    this.hasInput = ((html.toLowerCase().indexOf('<input') != -1) || (html.toLowerCase().indexOf('<textarea') != -1));

    this.isVisible = true;
  },
  hide:function(button) {
    if (this.toh) clearTimeout(this.toh);
    this.toh = null;

    this.dialog.style.visibility = 'hidden';
    this.dialogButtons.style.display = 'none';
    this.dialogOK.style.display = 'none';
    this.dialogCancel.style.display = 'none';
    this.dialogMaybe.style.display = 'none';

    var obj = this.obj;
    var okhnd = this.okhnd;
    var cancelhnd = this.cancelhnd;
    var maybehnd = this.maybehnd;

    this.type = '';
    this.obj = null;
    this.okhnd = null;
    this.cancelhnd = null;
    this.maybehnd = null;

    xopus_globs.allowEditKeys = this.prevAllowEditKeys;

    if (button == 'ok') {
      if (obj && okhnd) obj[okhnd](this.dialogContents);
      else if (okhnd) okhnd(this.dialogContents);
    } else if (button == 'cancel') {
      if (obj && cancelhnd) obj[cancelhnd](this.dialogContents);
      else if (cancelhnd) cancelhnd(this.dialogContents);
    } else if (button == 'maybe') {
      if (obj && maybehnd) obj[maybehnd](this.dialogContents);
      else if (maybehnd) maybehnd(this.dialogContents);
    }

    //hide dropshadow
if (lon)    xopus_globs.dropshadow.hide();

    this.isVisible = false;
  },
  position:function() {
    //position the dialog
    var w = this.dialog.offsetWidth;
    var h = this.dialog.offsetHeight;
    var sw = document.body.offsetWidth;
    var sh = document.body.offsetHeight;

    //check height
    if (xopus_globs.browser.ie) {
      if (h > sh - 70) {
        this.dialogContents.style.height = ((sh-70) - this.dialogButtons.offsetHeight - 20) + "px";
        var h = this.dialog.offsetHeight;
      }
    }

    this.dialog.style.top = Math.floor((sh-h)/3) + 'px';
    this.dialog.style.left = Math.floor((sw-w)/2) + 'px';
  },
  doMouseDown:function(evt, theWindow) {
    if (!this.isVisible) return true;

    this.doClick(evt);

    return false;
  },
  doClick:function(evt) {
    //see if we are visible
    if (!this.isVisible) return;

    //hide splash screens
    if (this.type == 'splash') {
      this.hide();
      return;
    }

    //flash title bar if the click was outside the dialog
    var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
    if (el.nodeType == 3) el = el.parentNode;
    while (el && (el.id != 'xopus_dialog_inner')) el = el.parentNode;
    if (!el) {
      this.flashTitleBar();
    }
  },
  doContextmenu:function(evt) {
    xopus_globs.framework.cancelEvent(evt);
  },
  doKeyDown:function(evt) {
    //leave untouched if invisible
    if (!this.isVisible) return true;

    //see if we have input fields in our content
    if (this.hasInput) {
      //let keys through
      return true;
    } else {
      //handle cursor left and right keys and block them
      //let return and escape go through
      switch (evt.keyCode) {
        case 37:
          //cursor left
          if (this.curButtonIdx > 0) {
            this.setButtonState(this.activeButtons[this.curButtonIdx], false);
            this.curButtonIdx--;
            this.setButtonState(this.activeButtons[this.curButtonIdx], true);
          }
          return false;
          break;
        case 39:
          //cursor right
          if (this.curButtonIdx < (this.activeButtons.length - 1)) {
            this.setButtonState(this.activeButtons[this.curButtonIdx], false);
            this.curButtonIdx++;
            this.setButtonState(this.activeButtons[this.curButtonIdx], true);
          }
          return false;
          break;
          case 13:
          case 27:
            return true;
            break;
      }

      //flash the title bar
      this.flashTitleBar();

      //block all other keys
      return false;
    }
  },
  doKeyPress:function(evt) {
    //leave untouched if invisible
    if (!this.isVisible) return true;

    //see if we have input fields in our content
    if (this.hasInput) return true;

    if (!this.useKeys) return false;

    //act on key
    if (this.type == 'splash') this.hide('');
    else {
      switch (evt.keyCode) {
        case 13:
          //return
          this.activeButtons[this.curButtonIdx].click();
          break;
        case 27:
          //escape
          if (this.cancelhnd) this.hide('cancel');
          else if (this.okhnd) this.hide('ok');
          else this.hide('maybe');
          break;
      }
    }

    return false;
  },
  doNothing:function(evt) {
    //leave untouched if invisible, cancel if visible
    return !this.isVisible;
  },
  setButtonState: function(el, asDefault) {
    if (asDefault) {
      el.style.borderWidth = "2px";
      el.style.padding = "0.1em 0px 0px 0px";
    } else {
      el.style.borderWidth = "1px";
      el.style.padding = "0.15em 1px 1px 1px";
    }
  },
  flashTitleBar:function() {
    //find titlebar
    var tbel = this.dialogContents.getElementsByTagName('h1');
    if (!tbel) return;
    else tbel = tbel[0];
    if (tbel.nodeName.toLowerCase() == "h1") {
      if (xopus_globs.doAnimations && xopus_globs.animator.isEnabled) {
        xopus_globs.animator.start([{ els:tbel, anims:{ prop:["backgroundColor"], target:["#C2E0D9"], duration:[600], loop:[true], repeat:[3], profile:[xopus_globs.animator.LINEAR] }}]);
      } else {
        tbel.style.backgroundColor = "#C2E0D9";
        setTimeout(function(){tbel.style.backgroundColor = "#61937D";}, 100);
        setTimeout(function(){tbel.style.backgroundColor = "#C2E0D9";}, 200);
        setTimeout(function(){tbel.style.backgroundColor = "#61937D";}, 300);
        setTimeout(function(){tbel.style.backgroundColor = "#C2E0D9";}, 400);
        setTimeout(function(){tbel.style.backgroundColor = "#61937D";}, 500);
      }
    }
  }
}

numScriptsLoading--;
