////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

/**
 * The class handles changes to the XML.
 */
function EventCenter() 
{
}

EventCenter.prototype=
{
  doWindowLoad:function(theWindow) {
    //catch events and send them to the ui object
    if (xopus_globs.browser.win) xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onkeydown", null, function(evt){ xopus_globs.eventCenter.doKeyDown(evt, theWindow); });
    else xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onkeypress", null, function(evt){ xopus_globs.eventCenter.doKeyDown(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onkeypress", null, function(evt){ xopus_globs.eventCenter.doKeyPress(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onkeyup", null, function(evt){ xopus_globs.eventCenter.doKeyUp(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onmousemove", null, function(evt){ xopus_globs.eventCenter.doMouseMove(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onmouseover", null, function(evt){ xopus_globs.eventCenter.doMouseOver(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onmouseout", null, function(evt){ xopus_globs.eventCenter.doMouseOut(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onmousedown", null, function(evt){ xopus_globs.eventCenter.doMouseDown(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onmouseup", null, function(evt){ xopus_globs.eventCenter.doMouseUp(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow, "onscroll", null, function(evt){ xopus_globs.eventCenter.doScroll(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "oncontextmenu", null, function(evt){ xopus_globs.eventCenter.doContextMenu(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "ondragstart", null, function(evt){ xopus_globs.eventCenter.doDragStart(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onselectstart", null, function(evt){ xopus_globs.eventCenter.doSelectStart(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document, "onselectionchange", null, function(evt){ xopus_globs.eventCenter.doSelectionChange2(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "ondrop", null, function(evt){ xopus_globs.eventCenter.doDrop(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onpaste", null, function(evt){ xopus_globs.eventCenter.doPaste(evt, theWindow); });
    xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onbeforepaste", null, function(evt){ xopus_globs.eventCenter.doBeforePaste(evt, theWindow); });

    //attach to events for the Xopus window only
    if (theWindow == xopus_globs.window) {
      xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onmouseover", null, function(evt){ xopus_globs.eventCenter.doMouseOverXopusWindow(evt, theWindow); });
      xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onmouseout", null, function(evt){ xopus_globs.eventCenter.doMouseOutXopusWindow(evt, theWindow); });
      xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onmousedown", null, function(evt){ xopus_globs.eventCenter.doMouseDownXopusWindow(evt, theWindow); });
      xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onmouseup", null, function(evt){ xopus_globs.eventCenter.doMouseUpXopusWindow(evt, theWindow); });
      xopus_globs.framework.attachEvent(theWindow.document.documentElement, "onclick", null, function(evt){ xopus_globs.eventCenter.doClickXopusWindow(evt, theWindow); });
      xopus_globs.framework.attachEvent(theWindow, "onresize", null, function(evt){ xopus_globs.eventCenter.doResizeXopusWindow(evt, theWindow); });
    }
  },
  
  doKeyDown:function(evt, theWindow) {

    //send keys to the dialog
    //do this first since we have modal dialogs only
    if (!xopus_globs.dialog.doKeyDown(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }
//__xopus_alert(evt.keyCode + ', ' + evt.charCode);


    //handle F5 and Ctrl-R events
    if ((evt.keyCode == 116) || ((evt.ctrlKey || evt.metaKey) && (evt.keyCode == 82))) {
//TODO
//      __xopus_alert("to do: handle reload event, show warning and options");
//
//      //stop the event
//      xopus_globs.framework.cancelEvent(evt);
//      return false;
      return;
    }

    //send keys to the contextmenu
    if (!xopus_globs.contextmenu.doKeyDown(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send keys to the toolbar
    if (!xopus_globs.toolbar.doKeyDown(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send keys to the editor
    if (!xopus_globs.ui.doKeyDownEditor(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //mozilla workaround for paste
    if (xopus_globs.browser.moz && (evt.ctrlKey || evt.metaKey) && (evt.charCode == 118)) {
      var curContext = Context.getCurrent();
      if (curContext) {
        curContext.xopus.textarea.value = '';
        xopus_globs.ui.hideSelection();
      }
    } else {
     //cancel backspace if no editor active
      if (!Context.hasCurrent() && (evt.keyCode == 8)) {
       //stop the event
        xopus_globs.framework.cancelEvent(evt);
        return false;
      }
     //cancel ctrl-keys
      if (evt.ctrlKey || evt.metaKey) {
       switch (evt.keyCode) {
        case 34:
        case 35:
        case 36:
        case 37:
        case 38:
        case 39:
        case 40:
        case 65:
         //let home, end, cursor up/down/left/right/a (all) through
          break;
        default:
         //stop the event
          xopus_globs.framework.cancelEvent(evt);
          return false;
        }
      }
    }
  },
  doKeyPress:function(evt, theWindow) {
    //send keys to the dialog
    if (!xopus_globs.dialog.doKeyPress(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send keys to the contextmenu
    if (!xopus_globs.contextmenu.doKeyPress(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //find the current context
    var curContext = Context.getCurrent();
    if (!curContext) return true;

    //Mozilla: send the keypress to the moz2ie keypress handler
    if (xopus_globs.browser.moz) {
      theWindow.document.__q42_keypress(evt, curContext.xopus.window);
    }

    //stop all key events outside of editable regions to prevent surfing, changing the selection and editing
    var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
    if (!el.isContentEditable) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //cancel ctrl-keys
    if (evt.ctrlKey || evt.metaKey) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }
  },
  doKeyUp:function(evt, theWindow) {
    //send keys to the dialog
    if (!xopus_globs.dialog.doNothing(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //mozilla workaround for paste
    if (xopus_globs.browser.moz && (evt.ctrlKey && (evt.keyCode == 86)) || (evt.metaKey && (evt.charCode == 118))) {
      var curContext = Context.getCurrent();
      if (curContext) {
        var txt = curContext.xopus.textarea.value;
        curContext.xopus.textarea.value = '';
        curContext.xopus.htmldocument.__q42_insertNodeAtSelection(curContext.xopus.htmldocument.createTextNode(txt));
//        xopus_globs.ui.restoreSelection();
//TODO!!!! OPLOSSING VINDEN VOOR DEZE PUINHOOP!!!
setTimeout(
  'var context = Context.getCurrent();'
  + 'var rng = xopus_globs.ui.restoreSelection();'
  + 'rng.expand("character", ' + txt.length + ');'
  + 'rng.collapse(false);'
  + 'rng.select();'
  + 'xopus_globs.ui.restoreSelection();', 300);
      }
    } else {
      //notify a possible selection change
      this.doSelectionChange(evt, theWindow);
    }

    //notify the current editor
    xopus_globs.ui.doKeyUpEditor(evt);
  },
  doMouseMove:function(evt, theWindow) {
    //send event to the tableeditor
    if (theWindow.xopus_tableeditor) theWindow.xopus_tableeditor.doMouseMove(evt, theWindow);
  },
  doMouseOver:function(evt, theWindow) {
    //send event to the dialog and contextmenu
    if (!xopus_globs.dialog.doNothing(evt) || !xopus_globs.contextmenu.doNothing(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send event to the ui
    if (!xopus_globs.ui.doMouseOver(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }
  },
  doMouseOut:function(evt, theWindow) {
    //send event to the dialog and contextmenu
    if (!xopus_globs.dialog.doNothing(evt) || !xopus_globs.contextmenu.doNothing(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send event to the ui
    if (!xopus_globs.ui.doMouseOut(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }
  },
  doMouseDown:function(evt, theWindow) {
    //send event to the dialog
    if (!xopus_globs.dialog.doMouseDown(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send event to the contextmenu
    if (!xopus_globs.contextmenu.doMouseDown(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }
  },
  doMouseUp:function(evt, theWindow) {
    //send keys to the dialog
    if (!xopus_globs.dialog.doNothing(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send event to the tableeditor
    if (theWindow.xopus_tableeditor && !theWindow.xopus_tableeditor.doClick(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //notify a possible selection change
    this.doSelectionChange(evt, theWindow);
  },
  doSelectStart:function(evt, theWindow) {
    //notify a possible selection change
    this.doSelectionChange(evt, theWindow);
  },
  doSelectionChange2:function(evt, theWindow) {
    //notify a possible selection change
    xopus_globs.ui.fixSelection(theWindow);
  },
  doScroll:function(evt, theWindow) {
    //send event to the ui
    xopus_globs.ui.doScroll(evt, theWindow);
  },
  doContextMenu:function(evt, theWindow) {
    //do not prevent the standard browser context menu if there is a selection of more than 0 characters
    var tr = theWindow.document.selection.createRange();
    if (tr.text && tr.text.length > 0) return;

    //send event to the tableeditor
    if (theWindow.xopus_tableeditor && !theWindow.xopus_tableeditor.doContextMenu(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //IE: allow context menu inside a contentEditable region
    if (xopus_globs.browser.ie) {
      //do not prevent the standard browser context menu if the event was inside a contenteditable region
      var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
      if (el.nodeType == 3) el = el.parentNode;
      if (el.isContentEditable) return;
    }

    //stop the event
    xopus_globs.framework.cancelEvent(evt);
    return false;
  },
  doDragStart: function(evt, theWindow) {
    //do not allow dragging for the time being.
    //especially not dragging of pieces of text
    
    //stop the event
    xopus_globs.framework.cancelEvent(evt);
    return false;
  },
  doDrop: function(evt, theWindow) {
    //only drop plain text, nothing else

    //a drop changes the selection
    this.doSelectionChange(evt, theWindow);

    //paste the dropped text
    var context=Context.getCurrent();
    context.xopus.doPlainTextPaste(evt.dataTransfer.getData('text'));

    //stop the event
    xopus_globs.framework.cancelEvent(evt);
    return false;
  },
  doPaste: function(evt, theWindow) {
    //only paste plain text, nothing else

    //paste the pasted text (not the html)
/*    var context=Context.getCurrent();
    try {
      context.xopus.doPlainTextPaste(theWindow.clipboardData.getData('html'));
    } catch(e) {}

    //stop the event
    xopus_globs.framework.cancelEvent(evt);
    return false;*/
    
    if (this.busyPasting) return;
    
    try 
    {
      var context = Context.getCurrent();
      if (context&&context.xopus) 
      {
        var editor  = context.getEditor();
        
        this.busyPasting = true;
        try {
          if (xopus_globs.browser.ie) 
            context.xopus.htmldocument.execCommand('Paste', false);
        } catch(e) {}
        this.busyPasting = false;

        context.xopus.handleChanges(editor);
        xopus_globs.ui.redraw(context.xopus);
        
        // fix for IE selection problem (bug?)
        var selObj = xopus_globs.ui.storeSelection();
        
        setTimeout(function() {xopus_globs.ui.restoreSelection(selObj);}, 50);
      }
    } catch(e) {
    }

    //stop the event
    xopus_globs.framework.cancelEvent(evt);
    return false;    
  },
  doBeforePaste: function(evt, theWindow) {
    //take control over paste

    //stop the event
    //xopus_globs.framework.cancelEvent(evt);
    //return false;
  },


  doMouseOverXopusWindow:function(evt, theWindow) {
    //send event to the dialog
    if (!xopus_globs.dialog.doNothing(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send event to the contextmenu
    if (!xopus_globs.contextmenu.doMouseOver(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send event to the toolbar
    if (!xopus_globs.toolbar.doMouseOver(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }
  },
  doMouseOutXopusWindow:function(evt, theWindow) {
    //send event to the dialog
    if (!xopus_globs.dialog.doNothing(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send event to the contextmenu
    if (!xopus_globs.contextmenu.doMouseOut(evt)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }

    //send event to the toolbar
    if (!xopus_globs.toolbar.doMouseOut(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }
  },
  doMouseDownXopusWindow:function(evt, theWindow) {
    //send event to the dialog
    if (!xopus_globs.dialog.doNothing(evt, theWindow)) {
      //let the event go
      return;
//      //stop the event
//      xopus_globs.framework.cancelEvent(evt);
//      return false;
    }

    //send event to the contextmenu
    if (!xopus_globs.contextmenu.doMouseDown(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }
  },
  doMouseUpXopusWindow:function(evt, theWindow) {
    //send event to the dialog
    if (!xopus_globs.dialog.doNothing(evt, theWindow)) {
      //let the event go
      return;
//      //stop the event
//      xopus_globs.framework.cancelEvent(evt);
//      return false;
    }

    //send event to the contextmenu
    if (!xopus_globs.contextmenu.doMouseUp(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }
  },
  doClickXopusWindow:function(evt, theWindow) {
    //send event to the dialog
    if (!xopus_globs.dialog.doNothing(evt, theWindow)) {
      //let the event go
      return;
//      //stop the event
//      xopus_globs.framework.cancelEvent(evt);
//      return false;
    }

    //send event to the toolbar
    if (!xopus_globs.toolbar.doClick(evt, theWindow)) {
      //stop the event
      xopus_globs.framework.cancelEvent(evt);
      return false;
    }
  },
  doResizeXopusWindow:function(evt, theWindow) {
    //send event to the contextmenu
    xopus_globs.contextmenu.doResize();

    //send event to the toolbar
    xopus_globs.toolbar.doResize();
  },


  doContextChange:function(context) {
    if (!context) return;

    //tell the tableeditor
    var theWindow = context.xopus.window;
    if (theWindow.xopus_tableeditor) theWindow.xopus_tableeditor.doContextChange(context);
  },
  doContextLose:function(context) {
    if (!context) return;

    //tell the tableeditor
    var theWindow = context.xopus.window;
    if (theWindow.xopus_tableeditor) theWindow.xopus_tableeditor.doContextLose(context);
  },


  doSelectionChange:function(evt, theWindow) {
    //notify a possible selection change
    xopus_globs.ui.doSelectionChange(evt, theWindow);
  }

};

numScriptsLoading--;