////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

/**
 * The Framework handles attaching and detaching events.
 */
function Framework() {
  this.handlers = {};
  this.idx = 0;
}

Framework.prototype = {
  attachEvent: function(el, eventname, object, method, params) {
    var fNormal = function (evt)  {
      //check for validity, leave if not valid
      //Mozilla has problems with these objects during unload
      if ((typeof(xopus_globs) == 'undefined') || !xopus_globs || !xopus_globs.status) return false;

      if (xopus_globs.browser.moz) {
        evt.srcElement = evt.currentTarget;
        window.event = evt;
      }
      
      if (object) return object[method](evt, params);
      else return method(evt, params);
    };
    
    var fSilentCatch = function ()
    {
      try
      {
        f1();
      }
      catch(e){}
    };
    
    var fun = xopus_globs.debug?fNormal:fSilentCatch;
    
    if (xopus_globs.browser.moz)
      el.addEventListener(eventname.substring(2), fun, false);
    else
      el.attachEvent(eventname, fun);
    
    var id = "" + this.idx++;
    this.handlers[id] = {elt: el, evt: eventname, fun: fun};
    
    return id;
  },
  
  detachEvent: function(id) {
    var hnd = this.handlers[id];
    this.handlers[id] = null;
    if (!hnd) return;

    if (xopus_globs.browser.moz) {
      hnd.elt.removeEventListener(hnd.evt.substring(2), hnd.fun, false);
    } else {
      hnd.elt.detachEvent(hnd.evt, hnd.fun);
    }
  },
  
  detachAll: function()
  {
    for (var id in this.handlers)
      this.detachEvent(id);
  },
  
  cancelEvent:function(evt) {
    evt.returnValue = false;
    evt.cancelBubble = true;
    if (evt.preventDefault) evt.preventDefault();
  }
};

numScriptsLoading--;
