////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

var xopus_globs = {
  version:"2.0.0.8",
  releaseday:"14",
  releasemonth:"10",
  releaseyear:"2002",

  browser:{
    win:(navigator.platform.toLowerCase().indexOf("win") != -1),
    mac:(navigator.platform.toLowerCase().indexOf("mac") != -1),
    name:((navigator.appName == 'Microsoft Internet Explorer')?'ie':((navigator.appName == 'Netscape')?'moz':'xxx')),
    moz:(navigator.appName == 'Netscape'),
    ie:(navigator.appName == 'Microsoft Internet Explorer'),
    version:1*(document.all?(navigator.appVersion.substring(navigator.appVersion.indexOf('MSIE'), navigator.appVersion.indexOf(';', navigator.appVersion.indexOf('MSIE'))).replace(/[^\d\.]/g, '')):(navigator.appVersion.replace(/[^\d\.]/g, '')))
  },

  debug:true,
  uniqueID:0,
  xopusStarted:false,
  isStandby:false,
  window:window,
  site:window.document.getElementById("site"),
  document:document,
  cms:CMS,
  cmsPostfix:cmsPostfix,
  xopi:{},
  useCookies:true,
  languages:{'en':'English', 'da':'Dansk', 'fi':'Suomi', 'cn':'&#20013;&#25991; (&#31616;&#20307;&#29256;)', 'ja':'&#x65E5;&#x672C;&#x8A9E;', 'pl':'Polski', 'de':'Deutsch', 'nl':'Nederlands', 'li':'Limburgs', 'ru':'&#x0420;&#x0443;&#x0441;&#x0441;&#x043A;&#x0438;&#x0439;', 'es':'Espa&#xF1;ol', 'po':'Portugu&#0234;s', 'de':'Deutsch', 'it':'Italiano', 'fr':'Fran&#xE7;ais', 'gr':'&#x0395;&#x03BB;&#x03BB;&#x03B7;&#x03BD;&#x03B9;&#x03BA;&#x03AC;', 'sk':'Sloven&#269;ina', 'uk':'&#1059;&#1082;&#1088;&#1072;&#1111;&#1085;&#1089;&#1100;&#1082;&#1072;', 'et':'Eesti keel'},
  defaultLanguage:'en',
  language:navigator.userLanguage,
  anyHasChanged:false,
  curHasChanged:false,
  basePath:basePath,
  symbols:['8364', '163', '167', '169', '174', '171', '187', '223', '181', 'separator0', '188', '189', '190', '176', '178', 'separator1', '224', '225', '226', '227', '228', 'separator2', '232', '233', '234', '235', 'separator3', '236', '237', '238', '239', 'separator4', '242', '243', '244', '245', '246', 'separator5', '249', '250', '251', '252'],
  doAnimations:true,
  contexthelphelp:true,
  
  showsplash:false,
  showwelcomemsg:true,
  logerrors:false,
  useDestructors:true,

  useTreeMorpher:true,
  useMozOpacity:true,

  status: null,
  help:null,
  animator:null,
  dropshadow:null,
  treeview:null,
  toolbardefinition:null,
  framework:null,
  errorHandler:null,
  objectFactory:null,
  locale:null,
  treemorpher:null,
  contextmenu:null,
  toolbar:null,
  utils:null,
  xmllib:null,
  eventCenter:null,
  editorDriver:null,
  dataDriver: null,
  schemaExtensions:null,
  
  allowEditKeys:true,
  selection:null,
  
  useXopusSOMinIE:true,
  enrichXSL:true,

  //persistent properties
  lastView:'-',
  
  init:function() {
    this.useXopusSOM = this.browser.moz ? true : this.useXopusSOMinIE;
    
    for (var theName in this) {
      if ((this[theName] === null) || (typeof(this[theName]) == "function") || (typeof(this[theName]) == "object")) continue;

      //see if we can get a value from cookie
      this[theName] = readCookie(theName, this[theName]);
    }

    //determine whether to use the treemorpher
    this.useTreeMorpher = true;

    //determine whether to use opacity
    this.useMozOpacity = this.browser.ie;
  },
  
  define:function(theName, theDefault) {
    this[theName] = readCookie(theName, theDefault);
  },

  set:function(thePath, theValue) {
    var names = thePath.split('.');
    var obj = this;
    for (var i=0; i<names.length-1; i++) obj = obj[names[i]];
  
    //store old value
    var oldValue = obj[names[names.length-1]];

    //store new value
    obj[names[names.length-1]] = theValue;

    //decide whether to fire
    if (theValue != oldValue) this.fire(thePath, theValue);
  },
  
  get:function(thePath) {
    var names = thePath.split('.');
    var obj = this;
    for (var i=0; i<names.length-1; i++)
      obj = obj[names[i]];
  
    return obj[names[names.length-1]];
  },
  
  store:function(thePath, theValue) {
    //store old value
    var oldValue = this[thePath];

    //store new value
    this[thePath] = theValue;

    //write the name/value to cookie
    writeCookie(thePath, theValue);

    //decide whether to fire
    if (theValue != oldValue) this.fire(thePath, theValue);
  },

  subscriptions:{},
  subscribe:function(thePath, theObj, theHnd) {
    if (!this.subscriptions[thePath]) this.subscriptions[thePath] = [];
    this.subscriptions[thePath][this.subscriptions[thePath].length] = {obj:theObj, hnd:theHnd};
  },

  fire:function(thePath, theValue) {
    var subscriptions = this.subscriptions[thePath];
    if (!subscriptions) return;

    for (var i=0; i<subscriptions.length; i++) {
      var subscription = subscriptions[i];
      if (!subscription) continue;

      if (subscription.obj && subscription.hnd) subscription.obj[subscription.hnd](thePath, theValue);
      else if (subscription.hnd) subscription.hnd(thePath, theValue);
    }
  },
  doNothing:function() {
    //do nothing, just a void-function place holder
  },
  destroyJSObject:function(jsobject) {
    //make sure there is a valid object
    if (!jsobject || (typeof(jsobject.constructor) != 'function') || (jsobject.destroy == this.doNothing)) return;

    if ((typeof(jsobject.destroy) != 'undefined') && (jsobject.destroy != this.doNothing)) {
      //call the destroy method, but make sure it will not call itself somehow
      jsobject._destroy = jsobject.destroy;

      //set the destroy method to void to prevent multiple destroys
      jsobject.destroy = this.doNothing;
      
      //now call the destroy
      jsobject._destroy();
    }

    //make sure we are supposed to use destructors
    if (!this.useDestructors) return;
  
var s = 'i just nulled the following properties:\n';
    //loop all properties of the object
    for (var p in jsobject) {
      //get the property
      var prop = jsobject[p];

      //leave functions alone
      if (typeof(prop) == 'function') continue;

      //see if the prop is an object and whether it has a destroy method
      if (prop && (typeof(prop) == 'object') && (typeof(prop.constructor) == 'function')) {
        //see if the object has a destroy method
        if ((typeof(prop.destroy) != 'undefined') && (prop.destroy != this.doNothing)) {
//alert('about to selfdestroy ' + p);
          //call the destroy method, but make sure it will not call itself somehow
          prop._destroy = prop.destroy;
          prop.destroy = this.doNothing;
          if (prop._destroy()) {
            //also call the default destroy because the custom destroy did not mind, otherwise it should have returned false
            this.destroyJSObject(prop);
          }
//NO AUTODESTRUCT YET, DESTROY ONLY OBJECTS THAT HAVE A DESTROY METHOD
//        } else {
////alert('about to destroy ' + p);
//          //no destroy: call the default destroy
//          this.destroyJSObject(prop);
        }
      } else {
        //clear the reference if not defined in prototype
        if (jsobject[p] != jsobject.constructor.prototype[p]) {
s += p + '\n';
          jsobject[p] = null;
          delete jsobject[p];
        }
      }
    }
//alert(s);
  }
};

numScriptsLoading--;
