////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

var animator_animator = null;

function startXopus() {
  xopus_globs.window = window;

  //create the framework object
  xopus_globs.framework = new Framework();

  //init all kind of stuff
  xopus_globs.init();

  //create all kinds of objects
  animator_animator = xopus_globs.animator = new Animator(25, 80);
  xopus_globs.animator.setEnabled(xopus_globs.doAnimations && xopus_globs.browser.ie);

  //create dropshadow object
  if ((typeof(DropShadow) != "undefined") && xopus_globs.useMozOpacity) xopus_globs.dropshadow = new DropShadow();
  else xopus_globs.dropshadow = { show:function(){}, hide:function(){} };

  xopus_globs.status = new Status();
  
  xopus_globs.errorHandler = new ErrorHandler();
  xopus_globs.objectFactory = new ObjectFactory();
  xopus_globs.xmllib = new XMLLib();
  xopus_globs.eventCenter = new EventCenter();
  xopus_globs.utils = new Utils();
  xopus_globs.treeview = new TreeView();
  
  // Create the i18n engine
  xopus_globs.locale = new Locale();
  if (!xopus_globs.errorHandler.hasLocale())
    xopus_globs.errorHandler.setLocale(xopus_globs.locale);

  //suscribe to a doAnimations change
  xopus_globs.subscribe('doAnimations', null, function() {xopus_globs.animator.setEnabled(xopus_globs.doAnimations); } );

  // Initialize cms driver
  xopus_globs.cmsdriver = new CMSDriver();

  //create the toolbardefinition
  xopus_globs.toolbardefinition = new ToolbarDefinition();

  //create the contextmenu
  xopus_globs.contextmenu = new ContextMenu();

  //create dialog system
  xopus_globs.dialog = new Dialog();

  //create help system
  xopus_globs.help = new Help('xopus', xopus_globs.language);

  //create the treemorpher
  if (typeof(TreeMorpher) != "undefined") xopus_globs.treemorpher = new TreeMorpher();
  else xopus_globs.useTreeMorpher = false;

  // Create the plugin drivers
  xopus_globs.editorDriver = new EditorDriver();
  xopus_globs.schemaExtensions = new SchemaExtensions();
  
  //create the toolbar
  xopus_globs.toolbar = new Toolbar(xopus_globs.toolbardefinition.logoMenu, xopus_globs.toolbardefinition.toolbar);

  // Initialize user interface
  xopus_globs.ui = new XopusUI();

  //suscribe to a language change
  xopus_globs.subscribe('language', Context, 'applyLanguage');

  // Initialize data handler
  xopus_globs.datadriver = new Databasedriver();

  //call the window load handler that will start to catch some events
  xopus_globs.eventCenter.doWindowLoad(window);

  //splash screen
  if (xopus_globs.showsplash) {
  xopus_globs.store('showsplash', false);
    xopus_globs.dialog.splash(xopus_globs.locale.getString('aboutxopusmsg'), 0);
  }

//xopus_globs.toolbar.show();

  // Welcome screen
  if (xopus_globs.showwelcomemsg && (xopus_globs.locale.getString('welcomemsg') != 'welcomemsg'))
    showWelcomeMessage();
};

function showWelcomeMessage() {
  xopus_globs.dialog.alert(xopus_globs.locale.getString('welcomemsg'), null, function() { var checkbox = document.getElementById('xopus_showwelcomemsg_never'); if (checkbox && checkbox.checked) xopus_globs.store('showwelcomemsg', false);});
}

function scanDocument(theWindow) {
  var hasXopi = false;

  // Find canvasses
  var elts = theWindow.document.getElementsByTagName('div');

  //because getElementsByTagName returns a 'live' collection
  //we have to put its contents now into our own array
  //to prevent new divs from appearing in the elts collection
  //only copy valid Xopus divs for this ocasion
  theWindow.canvasses = [];
  for (var i=0; i<elts.length; i++) {
    if (elts[i].getAttribute('xopus')) {
      theWindow.canvasses[theWindow.canvasses.length] = elts[i];
      hasXopi = true;
    }
  }

  for (var i=0; i<theWindow.canvasses.length; i++) {
    var canvas = theWindow.canvasses[i];

    // Find autostart and editable attributes
    var autostart = (canvas.getAttribute('autostart') == "true");
    canvas.isEditable = !(canvas.getAttribute('editable') == "false");
    canvas.isStarted = autostart && canvas.isEditable;
    
    var id = 'xopus' + xopus_globs.uniqueID++;
    xopus_globs.xopi[id] = canvas.xopusObj = new Xopus(id, canvas, theWindow);
  }

  if (hasXopi) {
    //do stuff that should probably go somewhere else
    xopus_globs.subscribe('curHasChanged', null, function(thePath, theValue) { xopus_globs.toolbar.setEnabled('standard', 'save', theValue); xopus_globs.toolbar.setEnabled('undo', 'reload', theValue); });
    xopus_globs.subscribe('anyHasChanged', null, function(thePath, theValue) { xopus_globs.toolbar.setEnabled('standard', 'saveall', theValue); });
  }
}

function scanFramesForEditors(theWindow) {
  var editorFound = false;
  for (var i=0; i<theWindow.frames.length; i++) {
    try {
      if (theWindow.frames[i].canvasses && (theWindow.frames[i].canvasses.length>0)) {
        for (var j=0; j<theWindow.frames[i].canvasses.length; j++) {
          if (theWindow.frames[i].canvasses[j].isStarted) {
            editorFound = true;
            break;
          }
        }
      } else {
        editorFound = scanFramesForEditors(theWindow.frames[i]);
      }
      if (editorFound) break;
    } catch(e) {}
  }
  return editorFound;
}

function exitXopus() {
  //save last action
  if (Context.hasCurrent()) {
    var context = Context.getCurrent();
    xopus_globs.ui.store();
  }

  //see if we have to save changes
  if (xopus_globs.anyHasChanged) {
    //ask for confirmation
    xopus_globs.dialog.show("alert", xopus_globs.locale.getString('savechanges?'), null, saveChangesBeforeExit, function(){}, exitXopusNow, null, xopus_globs.locale.getString('save'), xopus_globs.locale.getString('cancel'), xopus_globs.locale.getString('dontsave'), true, false);
  } else {
    exitXopusNow();
  }
}

function saveChangesBeforeExit() {
  //save changes
  xopus_globs.ui.saveAll();

  exitXopusNow();
}

function exitXopusNow() {
  xopus_globs.isExiting = true;

  // Find content to display
  var path = document.location.hash + "&";
  path = unescape(path.substring(path.indexOf("content=")+8, path.indexOf("&", path.indexOf("content="))));
  var contentURL = xopus_globs.cmsdriver.getExitURL(path);

  document.location.href = contentURL;
}

function standbyXopus() {
  //save last action
  if (Context.hasCurrent()) {
    var context = Context.getCurrent();
    xopus_globs.ui.store();
  }

  //see if we have to save changes
  if (xopus_globs.anyHasChanged) {
    //ask for confirmation
    xopus_globs.dialog.show("alert", xopus_globs.locale.getString('savechanges?'), null, saveChangesBeforeStandby, function(){}, standbyXopusNow, null, xopus_globs.locale.getString('save'), xopus_globs.locale.getString('cancel'), xopus_globs.locale.getString('dontsave'), true, false);
  } else {
    standbyXopusNow();
  }
}

function saveChangesBeforeStandby() {
  //save changes
  xopus_globs.ui.saveAll();

  standbyXopusNow();
}

function standbyXopusNow() {
  // Find content to display
  var path = document.location.hash + "&";
  path = unescape(path.substring(path.indexOf("content=")+8, path.indexOf("&", path.indexOf("content="))));
  var contentURL = xopus_globs.cmsdriver.getStandbyURL(path);

  //signal we are in standby mode
  xopus_globs.set("isStandby", true);

  if (contentURL) {
    document.getElementById('site').src = contentURL;
  } else {
    //disable all editors
    for (var id in xopus_globs.xopi) {
      xopus_globs.xopi[id].disable();
    }
    xopus_globs.set("xopusStarted", false);
  }
  
  // Clear the context.
  Context.currentID       = null;
  Context.cachedContext   = null;
  Context.previousContext = null;
}

numScriptsLoading--;
