<!--

 This stylesheet marks all nodes with the xpath in the processing instruction following the root node.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  
  <xsl:template match="*">
    <xsl:param name="xpath"><xsl:value-of select="substring-after(following-sibling::processing-instruction('xopus_element')[substring-before(., '=') = 'include'][1],'=')"/></xsl:param>
    <xsl:copy>
      <xsl:for-each select="@*">
        <xsl:copy-of select="."/>
      </xsl:for-each>
      <xsl:for-each select="@*">
        <xsl:if test="not(namespace-uri() = 'http://www.xopus.org/xmlns/id')">
          <xsl:processing-instruction name="xopus_attribute">
            <xsl:value-of select="name()"/>=<xsl:value-of select="$xpath"/>
          </xsl:processing-instruction>
        </xsl:if>
      </xsl:for-each>
      <xsl:apply-templates select="*|text()">
        <xsl:with-param name="xpath"><xsl:value-of select="$xpath"/></xsl:with-param>
      </xsl:apply-templates>
    </xsl:copy>
    <xsl:processing-instruction name="xopus_element">
      <xsl:value-of select="name()"/>=<xsl:value-of select="$xpath"/>
    </xsl:processing-instruction>    
  </xsl:template>
  
  <xsl:template match="text()">
    <xsl:param name="xpath"/>
    <xsl:processing-instruction name="xopus_separator"/>
    <xsl:value-of select="."/> 
    <xsl:processing-instruction name="xopus_text">
      <xsl:value-of select="$xpath"/>
    </xsl:processing-instruction>
  </xsl:template>
</xsl:stylesheet>