<!-- This stylesheet uses pipeline_copypis.xsl to keep our processing instructions. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:include href="xopus/pipeline/pipeline_copypis.xsl" xopus="true"/>
  
  <xsl:template match="xsl:value-of">
    <xsl:choose>
      <xsl:when test="starts-with(@select, 'string(') or starts-with(@select, 'boolean(') or starts-with(@select, 'number(')">
        <xsl:copy-of select="."/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:element name="xsl:apply-templates">
          <xsl:attribute name="select"><xsl:value-of select="@select"/></xsl:attribute>
          <xsl:attribute name="mode">valueOf</xsl:attribute>
        </xsl:element>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="xsl:copy-of">
      <xsl:element name="xsl:apply-templates">
      <xsl:attribute name="select"><xsl:value-of select="@select"/></xsl:attribute>
      <xsl:attribute name="mode">copyOf</xsl:attribute>
    </xsl:element>
  </xsl:template>
  
  <xsl:template match="xsl:copy">
    <xsl:element name="xsl:apply-templates">
      <xsl:attribute name="select">.</xsl:attribute>
      <xsl:attribute name="mode">copy</xsl:attribute>
      <xsl:element name="xsl:with-param">
        <xsl:attribute name="name">orgCopy</xsl:attribute>
        <xsl:copy-of select="."/>
      </xsl:element>
    </xsl:element>
  </xsl:template>
  
</xsl:stylesheet>