////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

function ToolbarDefinition() {
  //create logo menu items
  this.logoMenu = {id:'xopus', items:{
    'aboutxopus':  { icon:basePath + 'xopus/media/icons/xopus.gif', onclick:function() { xopus_globs.dialog.splash(xopus_globs.locale.getString('aboutxopusmsg', {version:xopus_globs.version, releaseday:xopus_globs.releaseday, releasemonth:xopus_globs.locale.getString('month' + xopus_globs.releasemonth), releaseyear:xopus_globs.releaseyear})); } },
    'separator3':   { },
    'settings':    { icon:basePath + 'xopus/media/icons/properties.gif',
      menu:{ items:{
        'animations':{ onclick:function() { xopus_globs.store('doAnimations', !xopus_globs.doAnimations); } },
        'contexthelphelpswitch':{ onclick:function() { xopus_globs.store('contexthelphelp', !xopus_globs.contexthelphelp); if (xopus_globs.contexthelphelp) { xopus_globs.help.isActive = false; xopus_globs.help.toggleActive(); } }},
        'welcomemsgswitch':{ onclick:function() { xopus_globs.store('showwelcomemsg', !xopus_globs.showwelcomemsg); if (xopus_globs.showwelcomemsg) showWelcomeMessage(); }},
        'logerrors':{ disabled:true, onclick:function() { xopus_globs.store('logerrors', !xopus_globs.logerrors); }}
      }}},
    'language':    { icon:basePath + 'xopus/media/icons/language.gif', menu:{ items:{} } },
//    'help':        { icon:basePath + 'xopus/media/icons/help.gif', disabled:true },
    'contexthelp': { icon:basePath + 'xopus/media/icons/contexthelp.gif', onclick:function() { xopus_globs.help.toggleActive(); }, checked:false },
    'separator4':   { },
    'doclanguage': { menu:{ items:{} } },
    'docview':        { icon:basePath + 'xopus/media/icons/view.gif', menu:{ items:{} } },
    'separator':   { },
    'xopus.org':   { href:'http://www.xopus.org' },
    'license':     { href:'http://xopus.org/index.jsp?menu=licensing' },
    'acknowledgements':     { href:'http://xopus.org/index.jsp?menu=acknowledgements' },
    'separator2':  { },
    'standby':     { icon:basePath + 'xopus/media/icons/standby.gif', onclick:function() { standbyXopus(); } },
    'exit':        { icon:basePath + 'xopus/media/icons/exit.gif', onclick:function() { exitXopus(); } }
  }};

  //create toolbar context menu items
  this.toolbar = {
    'standard':{ neverHide:true, items:{
      'save':{
        onclick:function(evt) { xopus_globs.ui.saveCurrent(); },
        onmouseover:function(evt){ xopus_globs.ui.showXopiBorders(); },
        onmouseout:function(evt){ xopus_globs.ui.hideXopiBorders(true); },
        shortcuts:'Ctrl+#83' },
      'saveall':{
        onclick:function(evt) { xopus_globs.ui.saveAll(); },
        onmouseover:function(evt){ xopus_globs.ui.showXopiBorders(true); },
        onmouseout:function(evt){ xopus_globs.ui.hideXopiBorders(true); },
        shortcuts:'Ctrl+Shift+#83' },
//      'help':{ obj:null, onclick:function() { __xopus_alert('help'); }, shortcuts:'#112' },
      'contexthelp':{ icon:basePath + 'xopus/media/icons/contexthelp.gif', onclick:function() { xopus_globs.help.toggleActive(); }, enabled:true }
    }},
    'node':{ neverHide:true, items:{
      'insertnode':   { hasMenu:true, onclick: function(id, evt){ xopus_globs.ui.showInsertMenu(evt, this.el); }, shortcuts:'Ctrl+#45,Ctrl+#96' },
      'moveupnode':   { hasMenu:true, onclick: function(id, evt){ xopus_globs.ui.showMoveUpMenu(evt, this.el); }, shortcuts:'Ctrl+#33' },
      'movedownnode': { hasMenu:true, onclick: function(id, evt){ xopus_globs.ui.showMoveDownMenu(evt, this.el); }, shortcuts:'Ctrl+#34' },
      'deletenode':   { hasMenu:true, onclick: function(id, evt){ xopus_globs.ui.showDeleteMenu(evt, this.el); }, shortcuts:'Ctrl+#46,Ctrl+#110' }
    }},
    'undo':{ items:{
      'reload':{
        onclick:function(evt) { xopus_globs.ui.reloadCurrent(); },
        onmouseover:function(evt){ xopus_globs.ui.showXopiBorders(); },
        onmouseout:function(evt){ xopus_globs.ui.hideXopiBorders(true); },
        shortcuts:'Ctrl+#82' },
      'undo':{ onclick: function() {
                          var curContext = Context.getCurrent();
                          var context = Context.getContext();
                          var xopus = context.xopus;
                          
                          // Store changes
                          if (curContext && curContext.hasChanged()) {
                            var editor = curContext.getEditor();
                            if (editor.editable) 
                              xopus.handleChanges(editor);
                          }
                          
                          xopus.doUndo();

                        }, shortcuts:'Ctrl+#90', enabled: false },
      'redo':{ onclick: function() { Context.getContext().getXopus().doRedo(); }, shortcuts:'Ctrl+#89,Ctrl+Shift+#90', enabled: false }
    }},
    'edit':{ items:{
      'cut':{ neverShow:xopus_globs.browser.moz, enabled:true, onclick:function(){ Context.getCurrent().xopus.doCut(); }, enabled:false, shortcuts:'Ctrl+#88' },
      'copy':{ neverShow:xopus_globs.browser.moz, enabled:true, onclick:function(){ Context.getCurrent().xopus.doCopy(); }, enabled:false, shortcuts:'Ctrl+#67' },
      'paste':{ neverShow:xopus_globs.browser.moz, enabled:true, onclick:function(){ Context.getCurrent().xopus.doPaste(); }, enabled:false, shortcuts:'Ctrl+#86' }
    }},
    'format':{ items:{
      'bold':        { 
        nodes: [{name: 'strong', namespace: 'http://www.w3.org/1999/xhtml'}, {name: 'strong', namespace: ''}, {name: 'b', namespace: 'http://www.w3.org/1999/xhtml'}, {name: 'b', namespace: ''}],
        onclick: function()
        { 
          if (xopus_globs.browser.ie)
            xopus_globs.ui.insertNodeAroundIE('bold', 'strong', this.activeName); 
          else
            xopus_globs.ui.insertNodeAround(this.nodes); 
        }, 
        shortcuts:'Ctrl+#66'},
      'italic':      { 
        nodes: [{name: 'em', namespace: 'http://www.w3.org/1999/xhtml'}, {name: 'em', namespace: ''}, {name: 'i', namespace: 'http://www.w3.org/1999/xhtml'}, {name: 'i', namespace: ''}],
        onclick: function()
        { 
          if (xopus_globs.browser.ie)
            xopus_globs.ui.insertNodeAroundIE('italic', 'em', this.activeName); 
          else
            xopus_globs.ui.insertNodeAround(this.nodes); 
        }, 
        shortcuts:'Ctrl+#73'},
      'superscript': { 
        nodes: [{name: 'sup', namespace: 'http://www.w3.org/1999/xhtml'}, {name: 'sup', namespace: ''}], 
        onclick: function()
        { 
          if (xopus_globs.browser.ie)
            xopus_globs.ui.insertNodeAroundIE('superscript', 'sup', this.activeName); 
          else
            xopus_globs.ui.insertNodeAround(this.nodes); 
        }, 
        shortcuts:'Ctrl+Shift+#190'},
      'subscript':   { 
        nodes: [{name: 'sub', namespace: 'http://www.w3.org/1999/xhtml'}, {name: 'sub', namespace: ''}], 
        onclick: function()
        { 
          if (xopus_globs.browser.ie)
            xopus_globs.ui.insertNodeAroundIE('subscript', 'sub', this.activeName); 
          else
            xopus_globs.ui.insertNodeAround(this.nodes);
        }, 
        shortcuts:'Ctrl+Shift+#188'}
    }},
//    'font':{ items:{
//      'fontsizeup':{ obj:null, onclick:null, shortcuts:'Ctrl-#221,Ctrl+Shift+190', insertnode:'font' },
//      'fontsizedown':{ obj:null, onclick:null, shortcuts:'Ctrl-#219,Ctrl+Shift+188', insertnode:'font' }
//    }},
    'list':{ items:{
      'bullititem':   { 
        nodes: [{name: 'ul', namespace: 'http://www.w3.org/1999/xhtml'}, {name: 'ul', namespace: ''}], 
        onclick: function(){ xopus_globs.ui.insertNodeAround(this.nodes, true, this.activeName); } },
      'numbereditem': { 
        nodes: [{name: 'ol', namespace: 'http://www.w3.org/1999/xhtml'}, {name: 'ol', namespace: ''}], 
        onclick: function(){ xopus_globs.ui.insertNodeAround(this.nodes, true, this.activeName); } }
//      'outdent':{ obj:null, onclick:null, shortcuts:'Ctrl+Shift+#77' },
//      'indent':{ obj:null, onclick:null, shortcuts:'Ctrl+#77' }
    }},
    'insert':{ items:{
      'insertlink':{
        nodes: [{name: 'a', namespace: 'http://www.w3.org/1999/xhtml'}, {name: 'a', namespace: ''}],
        onclick: function(){ insertLink1(this.nodes, this.activeName); }, 
        shortcuts:'Ctrl+#75' },
      'inserttable': { 
          nodes: [{name: 'table', namespace: 'http://www.w3.org/1999/xhtml'}, {name: 'table', namespace: ''}],
          onclick:function(){ xopus_globs.ui.insertNodeAround(this.nodes, true, this.activeName); }, 
        shortcuts:'Ctrl+#84' },
//      'insertpicture':{ neverShow:true, obj:null, onclick:null, insertnode:'img' },
      'insertsymbol':{ neverShow:false, onclick:function() { xopus_globs.toolbar.showInsertSymbolMenu(); }, shortcuts:'Ctrl+Shift+#83', inserttext:true }
    }}
  };

  //let the CMS change the toolbar definition
  if (typeof(xopus_globs.cmsdriver.changeToolbarDefinition) != 'undefined') {
    xopus_globs.cmsdriver.changeToolbarDefinition(this.logoMenu, this.toolbar);
  }

  xopus_globs.toolbarDefinition = this.toolbar;

  //define flags in xopus_globs
  //toolbar position
  xopus_globs.define('TB.curPosi', 0);
  xopus_globs.define('TB.statusVisible', true);
  
  //toolbar groups
  xopus_globs.define('TB.standard', true);
  xopus_globs.define('TB.undo', true);
  xopus_globs.define('TB.edit', true);
  xopus_globs.define('TB.format', true);
  xopus_globs.define('TB.font', false);
  xopus_globs.define('TB.list', true);
  xopus_globs.define('TB.insert', true);
  xopus_globs.define('TB.node', true);
  
  //toolbar items
  xopus_globs.define('TB.save', true);
  xopus_globs.define('TB.saveall', false);
  xopus_globs.define('TB.reload', true);
  xopus_globs.define('TB.language', false);
  xopus_globs.define('TB.help', false);
  xopus_globs.define('TB.contexthelp', true);
  xopus_globs.define('TB.undo', true);
  xopus_globs.define('TB.redo', true);
  xopus_globs.define('TB.cut', true);
  xopus_globs.define('TB.copy', true);
  xopus_globs.define('TB.paste', true);
  xopus_globs.define('TB.bold', true);
  xopus_globs.define('TB.italic', true);
  xopus_globs.define('TB.superscript', true);
  xopus_globs.define('TB.subscript', true);
  xopus_globs.define('TB.fontsizeup', true);
  xopus_globs.define('TB.fontsizedown', true);
  xopus_globs.define('TB.bullititem', true);
  xopus_globs.define('TB.numbereditem', true);
  xopus_globs.define('TB.indent', true);
  xopus_globs.define('TB.outdent', true);
  xopus_globs.define('TB.inserttable', true);
  xopus_globs.define('TB.insertpicture', true);
  xopus_globs.define('TB.insertsymbol', true);
  xopus_globs.define('TB.insertlink', true);
  xopus_globs.define('TB.moveupnode', true);
  xopus_globs.define('TB.movedownnode', true);
  xopus_globs.define('TB.insertnode', true);
  xopus_globs.define('TB.deletenode', true);

  //find languages and add them to the languages submenu
  var numLanguages = 0;
  var langItems = this.logoMenu.items.language.menu.items;
  for (var code in xopus_globs.languages) {
    numLanguages++;
    langItems[code] = { name:xopus_globs.languages[code], icon:xopus_globs.basePath + 'xopus/media/icons/languages/' + code + '.gif', onclick:function(id){ xopus_globs.locale.setLanguage(id); } };
  }

  //hide the language item if there is only one language
  if (numLanguages <= 1) {
    this.logoMenu.items.language.hidden = true;
  }

  //suscribe to a selection change
  xopus_globs.subscribe('selection', this, 'doSelectionChanged');
}

ToolbarDefinition.prototype = {
  doClickLogo:function(evt) {
    //don't do a thing if a dialog is visible
    if (xopus_globs.dialog.isVisible) return;

    var toolbar = xopus_globs.toolbar;
    switch (toolbar.curPosi) {
      case 0:
        toolbar.logoMenuDefinition.alignment = xopus_consts.BOTTOMLEFT;
        break;
      case 1:
        toolbar.logoMenuDefinition.alignment = xopus_consts.LEFTTOP;
        break;
      case 2:
        toolbar.logoMenuDefinition.alignment = xopus_consts.TOPLEFT;
        break;
      case 3:
        toolbar.logoMenuDefinition.alignment = xopus_consts.RIGHTTOP;
        break;
    }

    //prepare the exit and standby items
    toolbar.logoMenuDefinition.items.standby.hidden = (typeof(xopus_globs.cmsdriver.getStandbyURL) == 'undefined');
    toolbar.logoMenuDefinition.items.exit.hidden = (typeof(xopus_globs.cmsdriver.getExitURL) == 'undefined');

    //prepare the language menu
    var langItems = toolbar.logoMenuDefinition.items.language.menu.items;
    var numLanguages = 0;
    for (var lang in langItems) {
      numLanguages++;
      langItems[lang].bullited = (lang == xopus_globs.language);
    }

    //prepare the doclanguage menu
    if (Context.hasCurrent() || Context.hasPrevious()) {
      var context = Context.getContext();
      var xps = context.xopus;

      toolbar.logoMenuDefinition.items.doclanguage.menu.items = {};
      var doclangItems = toolbar.logoMenuDefinition.items.doclanguage.menu.items;
      var numDocLanguages = 0;
      var doclanguages = xps.getDocumentLanguages();
      for (var doclang in doclanguages) {
        numDocLanguages++;
        doclangItems[doclang] = {
          id:doclang,
          icon:basePath + 'xopus/media/icons/languages/' + doclang + '.gif',
          onclick:function(id){ xps.setDocumentLanguage(id); }
        }
      }
      for (var doclang in doclangItems)
        doclangItems[doclang].bullited = (doclang == xps.doclanguage);
        
      doclangItems['separator'] = {};
      
      // Add a way to add a language, if possible
      if (numDocLanguages < numLanguages) {
        doclangItems['adddoclanguage'] = {
          id:'adddoclanguage',
          onclick:function(){
            var options = '';
            var langItems = toolbar.logoMenuDefinition.items.language.menu.items;
            var doclangItems = toolbar.logoMenuDefinition.items.doclanguage.menu.items;
            for (var lang in langItems) {
              if (doclangItems[lang]) continue;
              options += '<option name="' + lang + '">' + xopus_globs.locale.getString(lang) + '</option>';
            }
            xopus_globs.dialog.alert(
              xopus_globs.locale.getString('adddoclanguagedialog', {options:options}),
              null,
              function(){
                if (Context.hasCurrent() || Context.hasPrevious()) {
                  var selbox = xopus_globs.window.document.getElementById('newdoclanguage');
                  if (selbox.selectedIndex < 0) return;
                  var newdoclang = selbox.options[selbox.selectedIndex].name;
                
                  var context = Context.getContext();
                  var xps = context.xopus;
                  xps.addDocumentLanguage(newdoclang);
                }
              },
              function(){}
            );
          }
        };
      }
      else
      {
        doclangItems['adddoclanguage'] = {
          id:'adddoclanguage',
          disabled: true };
      }
      
      // Add a way to remove a language, if possible
      if (numDocLanguages > 1)
      {
        doclangItems['remdoclanguage'] = {
          id:'remdoclanguage',
          onclick:function(){
            var options = '<option name="none"></option>';
            var doclanguages = xps.getDocumentLanguages();
            for (var lang in doclanguages)
              options += '<option name="' + lang + '">' + xopus_globs.locale.getString(lang) + '</option>';
            
            xopus_globs.dialog.alert(
              xopus_globs.locale.getString('remdoclanguagedialog', {options:options}),
              null,
              function(){
                if (Context.hasCurrent() || Context.hasPrevious()) {
                  var selbox = xopus_globs.window.document.getElementById('doclanguage');
                  if (selbox.selectedIndex < 1) return;
                  var doclang = selbox.options[selbox.selectedIndex].name;

                  var context = Context.getContext();
                  var xps = context.xopus;
                  xps.remDocumentLanguage(doclang);
                }
              },
              function(){}
            );
          }
        };      
      }
      else
      {
        doclangItems['remdoclanguage'] = {
          id:'remdoclanguage',
          disabled: true };
      }
      
      toolbar.logoMenuDefinition.items.doclanguage.hidden = (numDocLanguages < 1);
      toolbar.logoMenuDefinition.items.doclanguage.enabled = true;
      toolbar.logoMenuDefinition.items.doclanguage.icon = basePath + 'xopus/media/icons/languages/' + xps.doclanguage + '.gif';
    } else {
      toolbar.logoMenuDefinition.items.doclanguage.hidden = true;
      toolbar.logoMenuDefinition.items.doclanguage.enabled = false;
      toolbar.logoMenuDefinition.items.doclanguage.icon = null;
    }

    //prepare the view menu
    var viewsFound = 0;
    if (Context.hasCurrent() || Context.hasPrevious()) {
      var context = Context.hasCurrent()?Context.getCurrent():Context.getPrevious();
      var xps   = context.xopus;
      var views = xps.pipeline.views;
      var items = {};
      for (var viewid in views) {
        var view = views[viewid];
        viewsFound++;

        var viewIcon = xopus_globs.basePath + 'xopus/media/icons/' + viewid.toLowerCase() + '.gif';
        switch (viewid) {
          case 'defaultView':
          case 'wysiwygView':
          case 'treeView':
            break;
          default:
            viewIcon = null;
        }

        items[viewid] = {
          bullited:(xps.getCurrentView() == viewid),
          icon:viewIcon,
          onmouseover:function(evt) { xopus_globs.ui.showXopiBorders(); },
          onmouseout:function(evt) { xopus_globs.ui.hideXopiBorders(); },
          onclick:function(id){ xps.changeView(id); }
        };
        if (view.name) items[viewid].name = view.name;
      }
      toolbar.logoMenuDefinition.items.docview.menu = { items:items };
    }
    toolbar.logoMenuDefinition.items.docview.disabled = (viewsFound <= 1);

    //prepare the settings menu
    // TODO this is not the right place for these settings, make this more semantic. They should listen to property changes
    toolbar.logoMenuDefinition.items.settings.menu.items.animations.checked = xopus_globs.doAnimations;
    toolbar.logoMenuDefinition.items.settings.menu.items.contexthelphelpswitch.checked = xopus_globs.contexthelphelp;
    toolbar.logoMenuDefinition.items.settings.menu.items.welcomemsgswitch.hidden = (xopus_globs.locale.getString('welcomemsg') == 'welcomemsg');
    toolbar.logoMenuDefinition.items.settings.menu.items.welcomemsgswitch.checked = xopus_globs.showwelcomemsg;
    toolbar.logoMenuDefinition.items.settings.menu.items.logerrors.checked = xopus_globs.logerrors;

    xopus_globs.contextmenu.draw(xopus_globs.window, evt, toolbar.logoMenuDefinition);
  },
  doSelectionChanged:function(name, rng) {
    var isEditable = rng.parentElement().isContentEditable;
    var textSelected = (rng.htmlText.length > 0);
    var theContext = Context.getCurrent();
    if (theContext) var theDoc = theContext.htmldocument;
    
    xopus_globs.toolbar.setEnabled('edit', 'cut', theContext && (isEditable && textSelected && theDoc.queryCommandEnabled('cut')));
    xopus_globs.toolbar.setEnabled('edit', 'copy', theContext && (textSelected && theDoc.queryCommandEnabled('copy')));
    xopus_globs.toolbar.setEnabled('edit', 'paste', theContext && (isEditable && theDoc.queryCommandEnabled('paste')));
  }
};

numScriptsLoading--;
