////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////


function TreeMorpher() {
  this.isEnabled = true;
  this.uniqueID = 0;
  this.oldXML = null;
  this.newXML = null;
  
  this.createdNodes = null;
  this.deletedNodes = null;
  this.swappedNodes = null;
}

TreeMorpher.prototype =
{
  redrawContext: function(xopus, context)
  {
    if (!context) return true;
    
    var editor = context.getEditor();   
    if (!editor) return true;
    
    xpath = editor.xpath;
    var oldNode = this.oldXML.selectSingleNode('//*[@xpath="'+xpath+'"]');
    var newNode = this.newXML.selectSingleNode('//*[@xpath="'+xpath+'"]');

    // we need all of them, else do a complete redraw
    if (!oldNode || !newNode || !editor) return false;
    
    if (oldNode.xml == newNode.xml) return true;

    var source = [];

    // copy new content to oldXML and build source
    xopus_globs.utils.removeChildren(oldNode);
    for (var i=newNode.childNodes.length-1; i>=0; i--)
    {
      oldNode.insertBefore(newNode.childNodes[i].cloneNode(true), oldNode.firstChild);
      source.push(newNode.childNodes[i].xml);
    }
    
    // copy new content to html document
    editor.innerHTML = xopus.pipeline.XML2HTML(source.join(''));
    editor.xopusObject = null;
    
    return true;
  },
  
  morph: function(xopus, force)
  {
    //calculate the new xml
    this.newXML = xopus.render().xml;
   
    var changed = true;
    
    if (this.oldXML && !force)
    {
      //search last changed editor
      if (this.redrawContext(xopus, Context.getCurrent()) &&
          this.redrawContext(xopus, Context.getPrevious()))
      {
        //oldXML is now updated for the current and previous editors
        //compare old with new
        changed = (this.oldXML.xml != this.newXML.xml);
      }
    }

    //don't morph, just draw
    if (changed) 
      xopus.canvas.innerHTML = xopus.pipeline.XML2HTML(this.newXML.xml);

    this.oldXML = this.newXML;
    this.newXML = null;

    return;
  }
};

numScriptsLoading--;
