<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns="http://www.w3.org/1999/xhtml">
	<xsl:output method="xml"/>
	<!-- XMLSpy 	<xsl:template match="/*[local-name()='div' and namespace-uri()='http://www.w3.org/1999/xhtml']">
-->
	<xsl:template match="/">
		<xsl:choose>
			<xsl:when test="local-name()='div' and namespace-uri()='http://www.w3.org/1999/xhtml'">
				<xsl:copy>
					<xsl:apply-templates select="node()" mode="mix"/>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:apply-templates select="node()" mode="inline"/>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="*[not(.//text()) or .//text()[normalize-space(.)='']]" mode="mix"/>
	<xsl:template match="*[not(.//text())]" mode="inline"/>

<!--
	<xsl:template match="*[local-name()='td' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text() and not(.//text()[normalize-space(.)=''])]|
                       *[local-name()='li' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]" mode="mix">
		<xsl:if test="*|text()">
			<p>
				<xsl:apply-templates select="*|text()" mode="inline"/>
			</p>
		</xsl:if>
	</xsl:template>
-->

	<!-- inlines, mode=inline -->
	<xsl:template match="*[local-name()='b' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]|
                       *[local-name()='i' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]|
                       *[local-name()='strong' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]|
                       *[local-name()='em' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]|
                       *[local-name()='span' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]" mode="inline">
		<xsl:copy>
			<xsl:apply-templates select="*|text()" mode="inline"/>
		</xsl:copy>
	</xsl:template>
	
	<!-- a, mode=inline -->
	<xsl:template match="*[local-name()='a' and .//text()]" mode="inline">
		<xsl:copy>
			<xsl:if test="@href[not(starts-with(., ' ')) and not(starts-with(., 'javascript:'))]">
				<xsl:copy-of select="@href"/>
			</xsl:if>
			<xsl:apply-templates select="*|text()" mode="inline"/>
		</xsl:copy>
	</xsl:template>

	<!-- inlines, mode=mix -->
	<xsl:template match="*[local-name()='b' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]|
                       *[local-name()='i' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]|
                       *[local-name()='strong' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]|
                       *[local-name()='em' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]|
                       *[local-name()='span' and namespace-uri()='http://www.w3.org/1999/xhtml' and .//text()]" mode="mix">
		<xsl:copy>
			<xsl:apply-templates select="*|text()" mode="inline"/>
		</xsl:copy>
	</xsl:template>

	<!-- a, mode=mix-->
	<xsl:template match="*[local-name()='a' and .//text()]" mode="mix">
		<xsl:copy>
			<xsl:if test="@href[not(starts-with(., ' ')) and not(starts-with(., 'javascript:'))]">
				<xsl:copy-of select="@href"/>
			</xsl:if>
			<xsl:apply-templates select="*|text()" mode="mix"/>
		</xsl:copy>
	</xsl:template>

	<!-- h1-h3, mode=mix -->
	<xsl:template match="*[(local-name()='h1' or local-name()='h2' or local-name()='h3') and .//text() and not(.//text()[normalize-space(.)='']) ]" mode="mix">
		<xsl:copy>
			<xsl:apply-templates select="node()" mode="inline"/>
		</xsl:copy>
	</xsl:template>	

	<!-- h4-h6, mode=mix -->
	<xsl:template match="*[(local-name()='h4' or local-name()='h5' or local-name()='h6') and .//text() and not(.//text()[normalize-space(.)='']) ]" mode="mix">
		<h3>
			<xsl:apply-templates select="node()" mode="inline"/>
		</h3>
	</xsl:template>	

	<!-- p, mode=mix -->
	<xsl:template match="*[local-name()='p' and .//text() and not(.//text()[normalize-space(.)='']) ]" mode="mix">
		<xsl:choose>
			<xsl:when test="*[local-name()='table']">
				<xsl:for-each select="node()">
					<xsl:choose>
						<xsl:when test="local-name()='table' and 
	                       (*[local-name()='tbody' and 
			          *[local-name()='tr' and 
				    *[local-name()='td']]] 
				or 
				*[local-name='tr' and 
				  *[local-name='td']])
		            ">
							<xsl:apply-templates select="." mode="mix"/>
						</xsl:when>
						<xsl:otherwise>
							<p><xsl:apply-templates select="." mode="inline"/></p>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:apply-templates select="*|text()" mode="inline"/>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

     <!-- ul/ol, mode=mix -->
	<xsl:template match="*[(local-name()='ul' or local-name()='ol') and 
	                       *[local-name()='li']]"
		             mode="mix">
		<xsl:copy>
			<xsl:apply-templates select="*[local-name()='li']" mode="list"/>
		</xsl:copy>
	</xsl:template>

     <!-- ul/ol, mode=list -->
	<xsl:template match="*[local-name()='li']" mode="list">
		<xsl:copy>
			<xsl:apply-templates mode="mix"/>
		</xsl:copy>
	</xsl:template>

     <!-- table, mode=mix -->
	<xsl:template match="*[local-name()='table' and 
	                       (*[local-name()='tbody' and 
			          *[local-name()='tr' and 
				    *[local-name()='td']]] 
				or 
				*[local-name='tr' and 
				  *[local-name='td']])]
		            " mode="mix">
		<xsl:choose>
	 		<xsl:when test="*[local-name()='tbody']">
				<xsl:copy><xsl:apply-templates select="*[local-name()='tbody']" mode="table"/></xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy><tbody><xsl:apply-templates select="*[local-name()='tr']" mode="table"/></tbody></xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

     <!-- table, mode=table -->
     <!--
	<xsl:template match="*[local-name()='table' and 
	                       (*[local-name()='tbody' and 
			          *[local-name()='tr' and 
				    *[local-name()='td']]] 
				or 
				*[local-name='tr' and 
				  *[local-name='td']])]
		            " mode="table">
		<xsl:choose>
	 		<xsl:when test="*[local-name()='tbody']">
				<xsl:copy><xsl:apply-templates select="*[local-name()='tbody']" mode="table"/></xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy><tbody><xsl:apply-templates select="*[local-name()='tr']" mode="table"/></tbody></xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	
	</xsl:template>-->


     <!-- tbody, mode=table -->
	<xsl:template match="*[local-name()='tbody' and *[local-name()='tr']]" mode="table">
		<xsl:copy><xsl:apply-templates select="*[local-name()='tr']" mode="table"/></xsl:copy>
	</xsl:template>


     <!-- tr, mode=table -->
	<xsl:template match="*[local-name()='tr']" mode="table">
		<xsl:copy>
			<xsl:choose>
				<xsl:when test="*[local-name()='td']">
					<xsl:apply-templates select="*[local-name()='td']" mode="table"/>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:apply-templates mode='mix'/></td>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>


     <!-- td, mode=table -->
	<xsl:template match="*[local-name()='td']" mode="table">
		<xsl:copy>
			<xsl:apply-templates select="*|text()" mode="mix"/>
		<!--<xsl:choose>
			<xsl:when test='*|text()'>
			</xsl:when>
			<xsl:otherwise><xsl:text>lege cel</xsl:text></xsl:otherwise>
		</xsl:choose>-->
		</xsl:copy>
	</xsl:template>


	<xsl:template match="processing-instruction()"/>
</xsl:stylesheet>
