/*
 *  Copyright (C) Chaperon. All rights reserved.                               
 *  ------------------------------------------------------------------------- 
 *  This software is published under the terms of the Apache Software License 
 *  version 1.1, a copy of which has been included  with this distribution in 
 *  the LICENSE file.                                                         
 */

package net.sourceforge.chaperon.grammar.token.definition;

import net.sourceforge.chaperon.grammar.Grammar;

/**
 * This represents the characters of a character class
 *
 * @author Stephan Michels
 * @version $Revision: 1.2 $ $Date: 2002/05/06 16:22:56 $
 */
public interface CharacterClassElement extends Cloneable
{

  /**
   * Returns the to comparing characters
   *
   * @return To comparing characters
   */
  public String getCharacters();


  /**
   * Convert the character class element to a string
   *
   * @return Content of the character class element
   */
  public String toString();
}
